;============
;GUI Commands
;============
;This demo shows how GUI commands like LineBB, OvalBB, RectBB, and TextBB
;work. It also demonstrates color changing using pens and brushes in addition
;to the old-fashioned Color command.

;Please note that the ColorBB, SetPenBB, SeBrushBB, and SetFontColorBB
;commands are all especially slow in 8 bit mode because of the need for 
;color matching against a palette.

Include "../ExtendedBlitzLib.bb"
dllFileName$ = "../Blitz2DDll.dll" ;optional (if file not in same directory)
GraphicsBB(800,600,16,"Blitz Extended")

SetFontBB("Courier",14)
ColorBB(255,0,255) ;the usual way to set everything - text color, pen and brush

;Create a text image, which is used below.
textString$ = "Text Image" 
textImage = CreateImageBB(200,50) 
SetBufferBB(textImage)
	TextBB(0,0,textString$)	
SetBufferBB(BackBufferBB)
MaskImageBB(textImage,0,0,0) ;not really necessary here, but for demo purposes

While Not KeyDown(1)
	ClsBB()
	
	;Use text commands, writing directly on the screen.
	;Creating text images and drawing those instead
	;is usually faster.
	TextBB(0,0,"System Memory")	
	TextBB(0,20,"Available = " + AvailSysMemBB())		
	TextBB(0,40,"Total = " + TotalSysMemBB())	
	TextBB(550,0,"Video Memory")				
	TextBB(550,20,"Available = " + AvailVidMem())		
	TextBB(550,40,"Total = " + TotalVidMem())

	;Draw ovals and circles
	OvalBB(300,200,100,25,0)
	SetBrushBB(0,255,255,1,2)	
	OvalBB(300,300,100,25,1)
	SetBrushBB(0,0,255,1,3)		
	OvalBB(300,400,25,25,1)	

	;Draw rectangles and squares
	SetBrushBB(255,0,0)				
	RectBB(500,200,100,25,1)
	SetBrushBB(255,0,0,1,0)			
	RectBB(500,300,100,25,1)
	SetBrushBB(0,0,255,1,1)		
	RectBB(500,400,25,25,1)	
	
	;Draw lines
	LineBB(100,525,700,525)	
	SetPenBB(0,255,0,1,2)
	LineBB(100,550,700,550)	
	SetPenBB(0,0,255,2)	
	LineBB(100,575,700,575)	
	SetPenBB(255,255,0)	

	;Plot some random pixels in a 100x100 box
	For z = 1 To 100
		PlotBB(100+Rand(100),200+Rand(100),Rand(255),Rand(255),Rand(255))
	Next

	;Draw the text image on the screen		
	DrawImageBB(textImage,100,400) 
	
	FlipBB()
Wend

EndGraphicsBB()
End

	