;===============
;Image Filtering
;===============

;This demo illustrates bilinear filtering of 3D-enabled images. Bilinear
;filtering makes images a bit "fuzzier" and less pixelated/blocky.
;Sometimes this is desirable, sometimes not.

;This demo shows both situations. Check out the rotating spaceships.
;The non-filtered image on the left doesn't look as good as the
;filtered one on the right. On the other hand, there are times when
;you want the image rendered exactly, without filtering. Depending
;on your preferences, the unfiltered mage image on the left may
;be better than the filtered one on the right.


Include "../ExtendedBlitzLib.bb"
dllFileName$ = "../Blitz2DDll.dll" ;optional (if file not in same directory)
GraphicsBB(800,600,16) ;8-bit and 24-bit not supported

;Create star field
starField = CreateImageBB(800,600) 	
SetBufferBB starField
For x = 1 To 500	;place 500 random stars on the screen
	PlotBB (Rand(800),Rand(600),255,255,255)
Next
SetBufferBB BackBufferBB ;enable double buffering

;Load graphics
mousePointer = LoadImageBB("graphics/red pointer.bmp")
MaskImageBB(mousePointer,255,255,255)
AutoMidhandleBB(True)

freighter = Load3DImageBB("graphics/blue freighter.bmp") ;3D image
MaskImageBB(freighter,255,255,255)

freighter2 = CopyImageBB(freighter,0,1)
MaskImageBB(freighter2,255,255,255)
Filter3DImageBB(freighter2,True)

mage = Load3DImageBB("graphics/mage.bmp") ;3D image
MaskImageBB(mage,71,71,71)

mage2 = CopyImageBB(mage,0,1)
MaskImageBB(mage2,71,71,71)
Filter3DImageBB(mage2,True)

;Main loop
While Not KeyDown(1)
	DrawBlockBB starField,0,0
	
	;Draw spaceships
	angle = angle + 1
	If angle = 360 Then angle = 0
	Draw3dImageBB(freighter,350,200,255,100,100,angle) ;not filtered
	Draw3dImageBB(freighter2,450,200,255,100,100,angle)	 ;filtered

	;Draw mages
	Draw3dImageBB(mage,300,400,255,200,200) ;not filtered
	Draw3dImageBB(mage2,500,400,255,200,200) ;filtered		
			
	;Draw Mouse
	DrawImageBB(mousePointer,MouseCursorX,MouseCursorY)
	FlipBB()
Wend

EndGraphicsBB()
End