;============
;Image Loader
;============
;This demo illustrates the SetImageLoaderBB() command, which 
;modifies how the LoadImageBB, Load3DImageBB, and LoadAnimImageBB 
;commands work. There are currently two image loading settings:

;BMP Loader = SetImageLoaderBB(0). This is the default loader and
;the best one to use if you are loading bmps. It is fast and doesn't
;require any outside libraries to work. 

;Blitz Loader = SetImageLoaderBB(1). This loader uses the native
;Blitz loader and can load png, jpg, and bmp files. It does not
;work in 8 bit display mode, however. It is also a bit slow
;because it uses some pixel reading and writing to
;convert the loaded Blitz image to a format usable by the
;dll. This is the one to use if you have png or jpg graphics,
;but not so many that slow load times make much of a difference.

;External Loader = SetImageLoaderBB(2). This loader loads png, jpg,
;and bmp files quickly. It also supports loading them in 8-bit
;format, unlike the Blitz loader (don't forget to load a palette in
;bmp format, though).
;	Unfortunately, it also requires an additional external dll 
;to do the job (FreeImage.dll) which is several hundred K
;in size. You will need to include it along with your game in the
;same directory for this setting to work. It's worth it, however, 
;if you have a lot of pngs or jpgs. If for some reason you use this
;setting and the dll is not available, the code defaults to the (slower)
;Blitz loader. The Free Image dll is available for download here:
;  http://www.policyalmanac.org/games/FreeImage.dll


Include "../ExtendedBlitzLib.bb"
dllFileName$ = "../Blitz2DDll.dll" ;optional (if file not in same directory)
GraphicsBB(800,600,16)

;Default BMP loader (faster for bmps)
SetImageLoaderBB(0) ;default is 0, so this isn't really necessary.
mousePointer = LoadImageBB("graphics/red pointer.bmp")
MaskImageBB(mousePointer,255,255,255)
AutoMidHandleBB(True)

;Blitz loader (png/jpg) - works for bmps too, but BMP loader is faster
SetImageLoaderBB(1)
mage = LoadImageBB("graphics/mage.png")

;External loader (png/jpg) - requires FreeImage.dll in the same directory
SetImageLoaderBB(2) 
mage2 = LoadImageBB("graphics/mage.png")

;Main loop
While Not KeyDown(1)
	ClsBB()
	
	DrawBlockBB(mage,200,300)					
	DrawBlockBB(mage2,400,300)	
	DrawImageBB(mousePointer,MouseCursorX,MouseCursorY)

	FlipBB()
Wend

EndGraphicsBB()
End