;=====
;Mouse
;=====

;For technical reasons, the native Blitz mouse had to be replaced
;for users of B2D and B3D (but not B+).

;Extended B2D uses Direct Input, which is the input version of 
;DirectX. It is much faster than its Windows equivalent, just
;as DirectX graphics are much faster than Windows graphics.
;Unfortunately, a very small percentage of older systems
;do not support Direct Input (perhaps 5 percent of the total).

;For this reason, Mark Sibly abandoned Direct Input for the 
;slower Windows mouse in version 1.79 of B2D and B3D, and in 
;all versions of B+. Unfortunately, for technical reasons, the 
;Windows mouse can not be used with this dll. If you want 
;access to it, you should use B+ so you can use the native Blitz
;mouse commands instead.

;This demo illustrates the Extended B2D mouse commands. Please
;note that the MouseHitBB() commands are so fast that they 
;they only register as a flicker, and may not be noticable in this demo.

Include "../ExtendedBlitzLib.bb"
dllFileName$ = "../Blitz2DDll.dll" ;optional (if file not in same directory)
GraphicsBB(800,600,16)
SetFontBB("Arial",14)

;Load mouse pointer
mousePointer = LoadImageBB("graphics/red pointer.bmp")
MaskImageBB(mousePointer,255,255,255)

;Main loop
While Not KeyDown(1);keyboard commands still work the same			
	ClsBB()	
	
	TextBB(0,0,"MouseXBB = " + MouseXBB()) 
	TextBB(0,20,"MouseYBB = " + MouseYBB()) 	
	
	TextBB(0,60,"MouseDownBB(1) = " + MouseDownBB(1)) 
	TextBB(0,80,"MouseDownBB(2) = " + MouseDownBB(2))

	TextBB(0,120,"MouseHitBB(1) = " + MouseHitBB(1)) ;look quick!
	TextBB(0,140,"MouseHitBB(2) = " + MouseHitBB(2))  ;look quick!	
		
	DrawImageBB(mousePointer,MouseCursorX,MouseCursorY)						
	FlipBB()
Wend

EndGraphicsBB()
End