//-----------------------------------------------------------------------------
// EXTENDED BLITZ 2D DLL: This dll expands the capabilities of Blitz 2d.
// It replaces the native Blitz graphics and drawing commands. For more
// information, please see the attached Readme.txt file.

// Version 1.55 - By Patrick Lester. Updated July 27, 2003.
// Please forward suggestions/complaints to me at pwlester@policyalmanac.org

// Note to self: For version updates update this file, define#, top of
// ExtendedBlitzLib.bb and Readme.txt, both top and version history.
// - Uncomment two lines in GraphicsBB() for Blitz Plus.

// This code was written and compiled using Microsoft Visual C++ 6.0.
// You also will need the Direct X 7.0 SDK, and to install the lib
// and include files from the SDK to your C++ lib and include
// folders. You can get the DirectX 7.0 SDK (large!) here:
// http://download.microsoft.com/download/win98SE/SDK/7.0/W9X/EN-US/dx7sdk-700.1.exe
//-----------------------------------------------------------------------------

#define VERSION 155
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include <windowsx.h>
#include <ddraw.h>
#define DIRECTINPUT_VERSION 0x0700
#include <dinput.h>
#define D3D_OVERLOADS
#include <d3d.h>
#include <stdio.h>
#include <stdarg.h>
#include "FreeImage.h"
#define EXPORT _declspec(dllexport) int _cdecl 
#define VOIDEXPORT _declspec(dllexport) void _cdecl
#define BBDECL extern "C" _declspec(dllexport)
#define BBCALL _stdcall
#define STDPARAMS ( int *in,int in_size,long *out,int out_sz )
#define BYTEPARAMS (byte *in,byte in_size,byte *out,byte out_sz)
#define CHARPARAMS (char *in,char in_size,int *out,int out_sz)
#define SHORTPARAMS (short *in,short in_size,short *out,short out_sz)
#define INTPARAMS (int *in,int in_size,int *out,int out_sz)


//-----------------------------------------------------------------------------
// Name: Functions Declarations
// Desc: Needed for all publicly accessible functions in the dll
// _stdcall = called function cleans up the stack (Blitz userlibs)
// _cdecl = calling function cleans up the stack (Blitz CallDLL function)
//-----------------------------------------------------------------------------
extern "C"{  
EXPORT AlphaVertexBB INTPARAMS;
VOIDEXPORT AutoMaskImageBB INTPARAMS;
VOIDEXPORT AutoMaskImagePixelBB INTPARAMS;
VOIDEXPORT AutoMidHandleBB INTPARAMS;
EXPORT AvailVidMemBB STDPARAMS;
EXPORT AvailSysMemBB INTPARAMS;
EXPORT BackBufferBB INTPARAMS;
EXPORT ClsBB INTPARAMS;
VOIDEXPORT ClsColorBB INTPARAMS;
EXPORT ColorMatchBB INTPARAMS;
EXPORT CopyImageBB INTPARAMS;
EXPORT CopyRectBB INTPARAMS;
EXPORT CreateAlphaImageBB INTPARAMS;
EXPORT CreateImageBB INTPARAMS;
EXPORT Cull3DImagesBB INTPARAMS;
EXPORT Draw3DImageBB INTPARAMS;    //Draw3DImageUL = userlib version
EXPORT Draw3DQuadBB INTPARAMS;     //Draw3DQuadUL = userlib version
EXPORT DrawBlockBB STDPARAMS;      //DrawBlockUL = userlib version
EXPORT DrawImageBB STDPARAMS;      //DrawImageUL = userlib version
EXPORT DrawImageRectBB INTPARAMS;  
EXPORT EndGraphicsBB STDPARAMS;
EXPORT Filter3DImageBB INTPARAMS;
EXPORT FlipBB STDPARAMS;
EXPORT FlipImageBB INTPARAMS;
EXPORT FreeAllImagesBB INTPARAMS;
EXPORT FreeImageBB STDPARAMS;
EXPORT FrontBufferBB INTPARAMS;
EXPORT Get16BitFormatBB INTPARAMS;
EXPORT GetMouseSpeedBB INTPARAMS;
EXPORT GetValueBB STDPARAMS; 
EXPORT GetVersionBB INTPARAMS;
EXPORT GraphicsBB STDPARAMS;
EXPORT GraphicsBufferBB INTPARAMS;
EXPORT HandleImageBB INTPARAMS; //add userlib version
VOIDEXPORT HidePointerBB INTPARAMS;
EXPORT ImageHeightBB STDPARAMS;
EXPORT ImagesCollideBB INTPARAMS;
EXPORT ImagesOverlapBB INTPARAMS;
EXPORT ImageWidthBB STDPARAMS;
EXPORT ImageXHandleBB INTPARAMS;
EXPORT ImageYHandleBB INTPARAMS;
EXPORT LineBB STDPARAMS;
EXPORT Load3DImageBB (char *in,char in_size,long *out,int out_sz);
EXPORT loadDLL INTPARAMS;
EXPORT LoadFreeImageBB INTPARAMS;
EXPORT LoadImageBB INTPARAMS;
EXPORT MakeAnimatedBB INTPARAMS;
EXPORT MaskImageBB STDPARAMS;
EXPORT MessageBoxBB CHARPARAMS;
EXPORT MidHandleBB INTPARAMS;
EXPORT MouseHitBB INTPARAMS;
VOIDEXPORT MoveMouseBB INTPARAMS;
EXPORT OvalBB STDPARAMS;
EXPORT PlotBB STDPARAMS;
VOIDEXPORT ReadPaletteBB BYTEPARAMS;
EXPORT ReadPixelBB (int *in,int in_size, byte *out,byte out_sz);
EXPORT ReadPixelFastBB (int *in,int in_size, byte *out, byte out_sz);
EXPORT RectBB STDPARAMS;
EXPORT ResizeImageBB INTPARAMS;
EXPORT RotateImageBB INTPARAMS;
EXPORT SaveBufferBB CHARPARAMS;
EXPORT SetBrushBB STDPARAMS;
VOIDEXPORT SetBufferBB INTPARAMS;
EXPORT SetFontBB STDPARAMS;
EXPORT SetFontColorBB STDPARAMS;
VOIDEXPORT SetMouseSpeedBB INTPARAMS;
EXPORT SetPaletteBB BYTEPARAMS;
EXPORT SetPenBB STDPARAMS;
VOIDEXPORT ShowPointerBB INTPARAMS;
EXPORT TextBB STDPARAMS;
EXPORT Tint3DImageBB INTPARAMS;
EXPORT TotalSysMemBB STDPARAMS;
EXPORT TotalVidMemBB STDPARAMS; 
VOIDEXPORT UnlockBlitzMouseBB INTPARAMS;
VOIDEXPORT UpdateMouseBB INTPARAMS;
VOIDEXPORT UpdateWindowsMouseBB INTPARAMS;
EXPORT WindowStatusBB INTPARAMS;
VOIDEXPORT WritePaletteBB BYTEPARAMS;
EXPORT WritePixelBB INTPARAMS;
EXPORT WritePixelFastBB INTPARAMS;
}


//-----------------------------------------------------------------------------
// Name: Classes and Structs
//-----------------------------------------------------------------------------
class cStats3D //class containing info about a 3D image. Part of cImage.
{
public:
	bool isAlphaTextured; //false, true
	bool vertexAlphaUsed;
	DWORD vertexAlpha0;
	DWORD vertexAlpha1;
	DWORD vertexAlpha2;
	DWORD vertexAlpha3;
	COLORREF vertexColor;
	char filter; //0 = no filtering
};

class cImage //class containing info about an image (52 bytes)
{
public:
	LPDIRECTDRAWSURFACE7 pSurface; //pointer to the image
	int imageWidth;
	int imageHeight;
	int xHandle;
	int yHandle;
	bool isMasked; //false, true
	int convertedMaskColor;//mask color converted to used pixel format
	byte memLocation; //0 = VRAM, 1 = RAM
	bool imageIs3D; //0 = false, 1 = true
	cStats3D* pStats3D; //pointer to image's 3D statistics (see above)
	bool isAnimated; //if animated
	int frameWidth;//if animated, width of frame
	int frameHeight;//if animated, height of frame
	char firstFrame;//if animated, first frame
	char frameCount;//if animated, count of frames
	char framesWide;//if animated, different from frameCount if stacked.

	cImage* previousImage;//pointer to previous item in linked list
	cImage* nextImage;//pointer to next item in linked list

	//constructor member function
	cImage()
	{
	previousImage = NULL;
	nextImage = NULL;
	}
};


//-----------------------------------------------------------------------------
// Name: Function prototypes (where needed) 
//-----------------------------------------------------------------------------
DWORD ColorMatch(LPDIRECTDRAWSURFACE7 pdds, COLORREF rgb,
		bool imageIs3D );
cImage* CreateCImage (LPDIRECTDRAWSURFACE7 pSurface,
		int width, int height, 
		byte memLocation, int make3D, bool isAnimated,
	    int frameWidth, int frameHeight, 
		int firstFrame, int frameCount);
HRESULT LoadPalette(LPDIRECTDRAWPALETTE* ppPalette,const TCHAR* strBMP );
COLORREF ReadPixel (cImage* pImage, int x, int y, int mode);
int ReleaseBitmap(HDC hdcImage, HBITMAP hbm, LPDIRECTDRAWSURFACE7 pSurface=NULL);
int ReleaseObjectsBB(void);
int Graphics3D (void);
static HRESULT CALLBACK TextureSearchCallback(DDPIXELFORMAT* pddpf, VOID* param);


//-----------------------------------------------------------------------------
// Name: Globals
//-----------------------------------------------------------------------------
LPDIRECTDRAW7               g_pDirectDraw = NULL;
LPDIRECTDRAWSURFACE7        g_pFrontBuffer= NULL; 
LPDIRECTDRAWSURFACE7        g_pBackBuffer = NULL;
LPDIRECTDRAWPALETTE         g_pPalette = NULL;
PALETTEENTRY                g_PaletteEntry[256];
LPDIRECT3D7                 g_pD3D = NULL;
LPDIRECT3DDEVICE7           g_pD3DDevice = NULL;
D3DTLVERTEX                 g_Vertex[4]; //quad vertices for 3D images
int                         g_TextureSearchOption=0;
bool                        g_UseBlitzMouse = false;
LPDIRECTINPUT7              g_pDirectInput = NULL;
LPDIRECTINPUTDEVICE         g_pMouse=NULL;
DIMOUSESTATE                g_pMouseData;
int                         g_CurrentMouseX=0;
int                         g_CurrentMouseY=0;
int                         g_MouseSpeed=2;
DWORD                       g_ClsColor=0;
COLORREF                    g_FontColor=RGB(255,255,255);
HBRUSH                      g_hBrush=NULL;
HFONT                       g_hFont=NULL;
HPEN                        g_hPen=NULL;
int                         g_screenWidth = 0;
int                         g_screenHeight = 0;
int                         g_screenDepth = 0;
short                       g_screenFormat16Bit = 0;
bool                        g_AutoMidHandle=false;
bool                        g_AutoMask=false;
bool                        g_AutoMaskImagePixel=false;
int                         g_AutoMaskX=0;
int                         g_AutoMaskY=0;
COLORREF                    g_AutoMaskColor=0;
HWND                        g_hWndGame;

//Globals used to keep track of current drawing buffer
char                        g_pCurrentBuffer = 1;//1=front, 2 = back, 3 = image
cImage*                     g_pCurrentImage = NULL;//pointer to the cImage in buffer
LPDIRECTDRAWSURFACE7        g_pCurrentSurface = NULL;//pointer to the surface in buffer

//Globals used by cImage class	
cImage*                     g_pFirstImage = NULL;//pointer to first item in linked list
cImage*                     g_pLastImage = NULL;//pointer to last item in linked list

//Free Image.dll stuff
int                         g_FreeImage=0; //whether Free Image is being used.
HINSTANCE                   g_hDLL=NULL;// handle to DLL
typedef enum FREE_IMAGE_FORMAT (CALLBACK* LPFNDLLFUNC1) 
	(const char *format);
	LPFNDLLFUNC1 fpFreeImage_GetFIFFromFilename; //FreeImage_GetFIFFromFilename
typedef FIBITMAP * (CALLBACK* LPFNDLLFUNC2) 
	(FREE_IMAGE_FORMAT fif, const char *filename, int flags FI_DEFAULT(0));
	LPFNDLLFUNC2 fpFreeImage_Load;    // FreeImage_Load pointer
typedef UINT (CALLBACK* LPFNDLLFUNC3) (FIBITMAP *dib);
	LPFNDLLFUNC3 fpFreeImage_GetWidth;    // FreeImage_GetWidth pointer
	LPFNDLLFUNC3 fpFreeImage_GetHeight;    // FreeImage_GetHeight pointer
typedef BYTE* (CALLBACK* LPFNDLLFUNC4) (FIBITMAP *dib);
	LPFNDLLFUNC4 fpFreeImage_GetBits;    // FreeImage_GetBits pointer
typedef BITMAPINFO* (CALLBACK* LPFNDLLFUNC5) (FIBITMAP *dib);
	LPFNDLLFUNC5 fpFreeImage_GetInfo;    // FreeImage_GetInfo pointer
typedef void* (CALLBACK* LPFNDLLFUNC6) (FIBITMAP *dib);
	LPFNDLLFUNC6 fpFreeImage_Unload;    // FreeImage_Unload pointer

//Test variables used for debugging purposes. See GetValueBB().
int                         g_Test=0;
int                         g_Test1=0;
int                         g_Test2=0;
int                         g_Test3=0;
int                         g_Test4=0;
int                         g_Test5=0;



//-----------------------------------------------------------------------------
// Name: AlphaVertexBB
// Desc: Sets the vertex alpha for a 3D image.
//-----------------------------------------------------------------------------
int AlphaVertexBB INTPARAMS
{ 	
	//Get and translate the image pointer
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return -1;
	if(pImage->pSurface == NULL) return -2;

	pImage->pStats3D->vertexAlpha0 = *in; in++;
	pImage->pStats3D->vertexAlpha1 = *in; in++;
	pImage->pStats3D->vertexAlpha3 = *in; in++;
	pImage->pStats3D->vertexAlpha2 = *in; in++;

	if (pImage->pStats3D->vertexAlpha0 == 255 &&
		pImage->pStats3D->vertexAlpha1 == 255 &&
		pImage->pStats3D->vertexAlpha2 == 255 &&
		pImage->pStats3D->vertexAlpha3 == 255)
		pImage->pStats3D->vertexAlphaUsed = false;
	else
		pImage->pStats3D->vertexAlphaUsed = true;
	return 1;
}


//-----------------------------------------------------------------------------
// Name: AutoMaskImageBB
// Desc: Automatically masks all images loaded or created after the
//   command is called using the selected color.
//-----------------------------------------------------------------------------
void AutoMaskImageBB INTPARAMS
{ 	
	int switchOn = *in; in++; //0 = off, 1 = on.
	int r = *in; in++;
	int g = *in; in++;
	int b = *in;

	if (switchOn == 0)
		g_AutoMask = false;
	else
	{
		g_AutoMaskImagePixel = false;
		g_AutoMask = true;
		g_AutoMaskColor = RGB(r,g,b);
	}
}


//-----------------------------------------------------------------------------
// Name: AutoMaskImagePixelBB
// Desc: Automatically masks all images loaded or created after the
//   command is called using the color at the selected pixel location.
//-----------------------------------------------------------------------------
void AutoMaskImagePixelBB INTPARAMS
{ 	
	int switchOn = *in; in++; //0 = off, 1 = on.
	int x = *in; in++;
	int y = *in; in++;

	if (x < 0 || y < 0) return;//can't mask to a negative location

	if (switchOn == 0)
	{
		g_AutoMaskImagePixel = false;
	}
	else
	{
		g_AutoMask = false;
		g_AutoMaskImagePixel = true;
		g_AutoMaskX = x;
		g_AutoMaskY = y;
	}
}


//-----------------------------------------------------------------------------
// Name: AutoMidHandleBB
// Desc: Automatically sets the image handle of loaded images to the 
//	middle of the image. Only affects images loaded or created 
//	after this command is called.
//-----------------------------------------------------------------------------
void AutoMidHandleBB INTPARAMS
{ 	
	int inValue = *in;
	if (inValue == 0) g_AutoMidHandle = false;
	if (inValue == 1) g_AutoMidHandle = true;
}


//-----------------------------------------------------------------------------
// Name: AvailSysMemBB()
// Desc: Returns the available system memory (RAM) in bytes.
//-----------------------------------------------------------------------------
int AvailSysMemBB INTPARAMS
{ 	
	MEMORYSTATUS stat;
	GlobalMemoryStatus (&stat);
	return(stat.dwAvailPhys);
}


//-----------------------------------------------------------------------------
// Name: AvailVidMem()
// Desc: Returns the available video memory in bytes
//-----------------------------------------------------------------------------
int AvailVidMemBB STDPARAMS 
{
	DWORD totalVRAM=0;
	DWORD freeVRAM=0;
	DDSCAPS2 ddscaps;
	ZeroMemory(&ddscaps, sizeof(ddscaps));//clear memory block for structure
	ddscaps.dwCaps = DDSCAPS_VIDEOMEMORY;  
	g_pDirectDraw->GetAvailableVidMem(&ddscaps,&totalVRAM,&freeVRAM);
	return freeVRAM;
} 


//-----------------------------------------------------------------------------
// Name: BackBufferBB
// Desc: Returns a "pointer" to the back buffer
//-----------------------------------------------------------------------------
int BackBufferBB INTPARAMS
{
	return 2;
}


//-----------------------------------------------------------------------------
// Name: BltImage
// Desc: This function clips and draws an image on the screen.
//	It is called by DrawImageBB and DrawBlockBB.
//-----------------------------------------------------------------------------
int BltImage (cImage* pImage, int x, int y, int frame,
			  DWORD dwFlags, LPDDBLTFX lpDDBltFx)
{

	//If the image is totally off the screen, return
	if (x <= 0-pImage->frameWidth) return -10;
	if (x >= g_screenWidth) return -11;
	if (y <= 0-pImage->frameHeight) return -12;
	if (y >= g_screenHeight) return -13;

	//Calculate offset for animated images
	int xOffset = 0, yOffset = 0;
	if (pImage->isAnimated == true)
	{
		int xFrame = (frame-pImage->firstFrame) % pImage->framesWide;
		int yFrame = (frame-pImage->firstFrame)/pImage->framesWide;
		xOffset = xFrame*pImage->frameWidth;
		yOffset = yFrame*pImage->frameHeight;
	}

	//Compute clipped source rectangle
	RECT rectSrc;
	if (x < 0) //left clipped
		rectSrc.left = xOffset-x;
	else //left not clipped
		rectSrc.left = xOffset;
	if (x+pImage->frameWidth > g_screenWidth-1) //right clipped
		rectSrc.right = xOffset+g_screenWidth-x;
	else //right not clipped
		rectSrc.right = xOffset+pImage->frameWidth;
	if (y < 0)  //top clipped
		rectSrc.top = yOffset-y;
	else //top not clipped
		rectSrc.top = yOffset+0;
	if (y+pImage->frameHeight > g_screenHeight-1) //bottom clipped
		rectSrc.bottom = yOffset+g_screenHeight-y;
	else //bottom not clipped
		rectSrc.bottom = yOffset+pImage->frameHeight;

	//Compute clipped destination rectangle
	RECT rectDest;
	if (x < 0) //clipped
		rectDest.left = 0;
	else //not clipped
		rectDest.left = x;
	if (x+pImage->frameWidth > g_screenWidth-1)  //clipped
		rectDest.right = g_screenWidth;
	else //not clipped
		rectDest.right = x + pImage->frameWidth;
	if (y < 0)  //clipped
		rectDest.top = 0;
	else //not clipped
		rectDest.top = y;
	if (y+pImage->frameHeight > g_screenHeight-1)  //clipped
		rectDest.bottom = g_screenHeight;
	else //not clipped
		rectDest.bottom = y + pImage->frameHeight;


	//If source and destination images are both standard 2D images,
	//use Blt to draw the image.
	bool dxBlit = false;
	if (g_pCurrentBuffer != 3)
	{
		if (pImage->imageIs3D == false) dxBlit = true;
	}
	else if (g_pCurrentImage->imageIs3D == false)
	{
		if (pImage->imageIs3D == false) dxBlit = true;
	}
	if (dxBlit == true)
	{
		//Blit it to the current buffer	
		return g_pCurrentSurface->Blt(
			&rectDest, //Destination RECT
			pImage->pSurface,  //lpDDSrcSurface
			&rectSrc, //Source RECT
			dwFlags, //flags
			lpDDBltFx); //special effects
	}

	//Otherwise, copy the image over using the slower Windows BitBlt
	else 
	{
		HDC hdcSrc;
		HDC hdcDest;  //handle of display version of image
		if (pImage->pSurface->GetDC(&hdcSrc) == DD_OK &&
			 g_pCurrentSurface->GetDC(&hdcDest) == DD_OK)
		{
			BitBlt(
				hdcDest,	// handle of destination DC
				rectDest.left,		// x-coord of destination upper-left corner
				rectDest.top,		// y-coord of destination upper-left corner
				rectDest.right-rectDest.left, // width of destination rectangle
				rectDest.bottom-rectDest.top, // height of destination rectangle
				hdcSrc,	// handle of source DC
				rectSrc.left, // x-coord of source upper-left corner
				rectSrc.top, // y-coord of source upper-left corner
				SRCCOPY );	// raster operation code
		}		
		g_pCurrentSurface->ReleaseDC(hdcDest);
		pImage->pSurface->ReleaseDC(hdcSrc);
		return 1; 
	}
}


//-----------------------------------------------------------------------------
// Name: BltImageSection
// Desc: This function clips and draws a section of an image on the screen.
//	It is called by CopyRectBB and DrawImageRectBB.
//-----------------------------------------------------------------------------
int BltImageSection (LPDIRECTDRAWSURFACE7 pSourceImage, 
			LPDIRECTDRAWSURFACE7 pDestImage, 
			int x1, int y1, //where in the source image to start drawing
			int x2, int y2, //where in the destination image to start drawing
			int width, int height,
			DWORD dwFlags, LPDDBLTFX lpDDBltFx, bool dxBlit)
{

	//If the image is totally off the screen, return
	if (x2 <= 0-width) return 0;
	if (x2 >= g_screenWidth) return 0;
	if (y2 <= 0-height) return 0;
	if (y2 >= g_screenHeight) return 0;

	//Compute clipped source rectangle
	RECT rectSrc;
	if (x2 < 0) //left clipped
		rectSrc.left = x1-x2;
	else //left not clipped
		rectSrc.left = x1;
	if (x2+width > g_screenWidth-1) //right clipped
		rectSrc.right = x1 - x2 + g_screenWidth;
	else //right not clipped
		rectSrc.right = x1+width;
	if (y2 < 0)  //top clipped
		rectSrc.top = y1-y2;
	else //top not clipped
		rectSrc.top = y1;
	if (y2+height > g_screenHeight-1) //bottom clipped
		rectSrc.bottom = y1 - y2 + g_screenHeight;
	else //bottom not clipped
		rectSrc.bottom = y1+height;

	//Compute clipped destination rectangle
	RECT rectDest;
	if (x2 < 0) //clipped
		rectDest.left = 0;
	else //not clipped
		rectDest.left = x2;
	if (x2+width > g_screenWidth-1)  //clipped
		rectDest.right = g_screenWidth;
	else //not clipped
		rectDest.right = x2 + width;
	if (y2 < 0)  //clipped
		rectDest.top = 0;
	else //not clipped
		rectDest.top = y2;
	if (y2+height > g_screenHeight-1)  //clipped
		rectDest.bottom = g_screenHeight;
	else //not clipped
		rectDest.bottom = y2 + height;

	//If source and destination images are both standard 2D images,
	//use Blt to draw the image.
	if (dxBlit == true)
	{
		//Blit it to the current buffer	
		return pDestImage->Blt(
			&rectDest, //Destination RECT
			pSourceImage,  //lpDDSrcSurface
			&rectSrc, //Source RECT
			dwFlags, //flags
			lpDDBltFx); //special effects
	}

	//Otherwise, copy the image over using Windows BitBlt
	else 
	{
		HDC hdcSrc;
		HDC hdcDest;  //handle of display version of image
		if (pSourceImage->GetDC(&hdcSrc) == DD_OK &&
			pDestImage->GetDC(&hdcDest) == DD_OK)
		{
			BitBlt(
				hdcDest,	// handle of destination DC
				rectDest.left,		// x-coord of destination upper-left corner
				rectDest.top,		// y-coord of destination upper-left corner
				rectDest.right-rectDest.left, // width of destination rectangle
				rectDest.bottom-rectDest.top, // height of destination rectangle
				hdcSrc,	// handle of source DC
				rectSrc.left, // x-coord of source upper-left corner
				rectSrc.top, // y-coord of source upper-left corner
				SRCCOPY );	// raster operation code
		}		
		pDestImage->ReleaseDC(hdcDest);
		pSourceImage->ReleaseDC(hdcSrc);
		return 1; 
	}

}


//-----------------------------------------------------------------------------
// Name: ClsBB
// Desc: Clears the screen with the designated CLS color, which is black
// unless changed by the ClsColorBB() command. You can also use this command
// to clear just a portion of the current drawing buffer instead of the
// whole thing.
//-----------------------------------------------------------------------------
int ClsBB INTPARAMS
{
	//Get incoming info
	int x = *in; in++;
	int y = *in; in++;	
	int width = *in; in++;	
	int height = *in; in++;

	//Error check: can't Cls 3D images
	if (g_pCurrentBuffer == 3)
	{
		if (g_pCurrentImage->imageIs3D == true) return 0;
	}

	HRESULT hr;
	DDBLTFX ddbltfx;
	ZeroMemory( &ddbltfx, sizeof(ddbltfx));
	ddbltfx.dwSize      = sizeof(ddbltfx);
	ddbltfx.dwFillColor = g_ClsColor;

	//If CLSing the entire screen
	if (width == -1 || height == -1)
	{
		hr = g_pCurrentSurface->Blt(
		NULL, //destination rectangle of blit (0 = blit entire surface)
		NULL, //address of source surface blitted from (0 used here)
		NULL, //source rectangle of blit (0 = blit from entire surface)
		DDBLT_COLORFILL | DDBLT_WAIT, //blit flags; DDBLT_COLORFILL = use dwFillColor member
		// of the DDBLTFX structure as the RGB color that fills the destination
		&ddbltfx );//address of special effects ddbltfx structure created above
	}

	//If CLSing a portion of the screen
	else
	{
		//Compute destination rectangle
		RECT rectDest;
		rectDest.left=x;
		rectDest.right=x+width;;
		rectDest.top=y;
		rectDest.bottom=y+height;

		hr = g_pCurrentSurface->Blt(
		&rectDest, //destination rectangle of blit (0 = blit entire surface)
		NULL, //address of source surface blitted from (0 used here)
		NULL, //source rectangle of blit (0 = blit from entire surface)
		DDBLT_COLORFILL | DDBLT_WAIT, //blit flags; DDBLT_COLORFILL = use dwFillColor member
		// of the DDBLTFX structure as the RGB color that fills the destination
		&ddbltfx );//address of special effects ddbltfx structure created above
	}

	if (hr == DD_OK) 
		return 1;
	else
		return hr;
}


//-----------------------------------------------------------------------------
// Name: ClsColorBB
// Desc: Changes the color for the Cls command. Default is black.
//-----------------------------------------------------------------------------
void ClsColorBB INTPARAMS
{
	int r = *in; in++;
	int g = *in; in++;
	int b = *in;

	COLORREF rgb = RGB(r,g,b);
	if (rgb == 0) g_ClsColor=0;
	if (rgb != 0) g_ClsColor = ColorMatch(g_pFrontBuffer, rgb, false);
}


//-----------------------------------------------------------------------------
// Name: ColorMatch()
// Desc: This function translates a specified rgb color value into a format
//	appropriate to the color depth being used. For example, if 8 bit color
//	depth is used, it translates it into the appropriate palette entry. 
//	If 16 bit color depth is used, it translates the rgb into a 16 bit 
//	color, etc.
//	
//	Used by MaskImageBB, ClsBB, and ColorMatchBB
//-----------------------------------------------------------------------------
DWORD ColorMatch(LPDIRECTDRAWSURFACE7 pdds, COLORREF rgb, 
				 bool imageIs3D = false)
{
	//If in 8 bit mode or using a 3D image, use GetPixel/SetPixel
	if (g_screenDepth == 8 || imageIs3D == true)
	{

    COLORREF                rgbT;
    HDC                     hdc;
    DWORD                   dw = CLR_INVALID;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hres;
    // Use GDI SetPixel to color match for us
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        rgbT = GetPixel(hdc, 0, 0);     // Save current pixel value
        SetPixel(hdc, 0, 0, rgb);       // Set our value
        pdds->ReleaseDC(hdc);
    }

    //Now lock the surface so we can read back the converted color
    ddsd.dwSize = sizeof(ddsd);
    while ((hres = pdds->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING);
    if (hres == DD_OK)
    {
        dw = *(DWORD *) ddsd.lpSurface;// Get DWORD
        if (ddsd.ddpfPixelFormat.dwRGBBitCount < 32)
            dw &= (1 << ddsd.ddpfPixelFormat.dwRGBBitCount) - 1;// Mask it to bpp
        pdds->Unlock(NULL);
    }

    //Now put the color that was there back.
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        SetPixel(hdc, 0, 0, rgbT);
        pdds->ReleaseDC(hdc);
    }
    return dw;
	}

	//If in 16 bit mode
	else if (g_screenDepth == 16)
	{
		if (g_screenFormat16Bit == 555)	
		{
			int b = (rgb >> 16 & 0xff)/8;
			int g = (rgb >> 8 & 0xff)/8;
			int r = (rgb & 0xff)/8;
			return r << 10 | g << 5 | b;		
		}
		else //if 565
		{
			int b = (rgb >> 16 & 0xff)/8;
			int g = (rgb >> 8 & 0xff)/4;
			int r = (rgb & 0xff)/8;
			return r << 11 | g << 5 | b;
		}
	}

	//If in 24/32 mode
	else
	{
		int b = rgb >> 16 & 0xff;
		int g = rgb >> 8 & 0xff;
		int r = rgb & 0xff;
		return r << 16 | g << 8 | b;
	}
}


//-----------------------------------------------------------------------------
// Name: ColorMatchBB
// Desc: Used to retrieve the closest pixel value to a given rgb. The
//  returned pixel value will vary based upon the display mode that is
//  being used. This command is primarily used in 8-bit mode when trying
//  find the closest palette entry to a particular rgb value.
//-----------------------------------------------------------------------------
int ColorMatchBB INTPARAMS
{
	int r = *in; in++;
	int g = *in; in++;
	int b = *in;
	return ColorMatch(g_pBackBuffer,RGB(r,g,b));
}


//-----------------------------------------------------------------------------
// Name: CopyImageBB
// Desc: Creates a new image that is a copy of another, pre-existing
//	image. Not currently usable with 3D images.
//-----------------------------------------------------------------------------
int CopyImageBB INTPARAMS
{
	//Get pointer to image that is being copied.
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0;//not front or backbuffer
	cImage* pImageSource = (cImage*) pointer;	
	if(pImageSource == NULL) return 0;
	if(pImageSource->pSurface == NULL) return 0;
	int loadTo = *in; in++; //flag that says whether to create image in VRAM/RAM
	int make3D = *in; in++; //0 = normal image, 1 = make 3D image

	//Error check: no 3D animated images
	if (pImageSource->isAnimated == true && make3D == 1)
		return 0;

	//Set up the Direct Draw surface description
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);
	if (make3D == 0)//if it is a normal 2D image
	{
	ddsd.dwFlags = DDSD_CAPS | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT | //dwHeight member is valid
                 DDSD_WIDTH;   //dwWidth member is valid
	if (loadTo == 0) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN; 
	if (loadTo == 1) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN 
		| DDSCAPS_SYSTEMMEMORY; //load to RAM if loadTo == 1
	}
	else //if it is a 3D image
	{
	ddsd.dwFlags = DDSD_CAPS       | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT       | //dwHeight member is valid
                 DDSD_WIDTH        | //dwWidth member is valid
                 DDSD_PIXELFORMAT  |
		 DDSD_TEXTURESTAGE | //it's a D3D texture
                 DDSD_CKSRCBLT;      //color key enabled
	ddsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE; 
	g_pD3DDevice->EnumTextureFormats( TextureSearchCallback, &ddsd.ddpfPixelFormat );
	if( 0L == ddsd.ddpfPixelFormat.dwRGBBitCount )
        return 0;
	}
	ddsd.dwWidth = pImageSource->imageWidth;
	ddsd.dwHeight = pImageSource->imageHeight;

	//Create the Direct Draw surface 
	LPDIRECTDRAWSURFACE7 pSurfaceNew; //pointer to Direct Draw surface
	if (g_pDirectDraw->CreateSurface(
		&ddsd, //address of above DDSURFACEDESC2 structure that describes surface
		&pSurfaceNew, //address of the variable pointing to the surface
		NULL)  //advanced COM stuff
		!= DD_OK) return 0;

	//If original and new images are both standard 2D images,
	//use Blt to copy the image.
	if (pImageSource->imageIs3D == false && make3D == 0)
	{
		pSurfaceNew->Blt(
			NULL, //Destination RECT
			pImageSource->pSurface,  //lpDDSrcSurface
			NULL, //Source RECT
			0, //flags
			NULL); //special effects
	}
	else //Otherwise, copy the image over using Windows BitBlt
	{
		HDC hdcSrc;
		HDC hdcDest;  //handle of display version of image
		if (pImageSource->pSurface->GetDC(&hdcSrc) == DD_OK &&
			 pSurfaceNew->GetDC(&hdcDest) == DD_OK)
		{
			BOOL result = BitBlt(
				hdcDest,	// handle of destination DC
				0,		// x-coord of destination upper-left corner
				0,		// y-coord of destination upper-left corner
				pImageSource->imageWidth, // width of destination rectangle
				pImageSource->imageHeight, // height of destination rectangle
				hdcSrc,	// handle of source DC
				0, // x-coord of source upper-left corner
				0, // y-coord of source upper-left corner
				SRCCOPY );	// raster operation code
		}		
		pSurfaceNew->ReleaseDC(hdcDest);
		pImageSource->pSurface->ReleaseDC(hdcSrc);
	}

	//Create a new cImage class instance to hold image data 
	cImage* pImageNew = CreateCImage (pSurfaceNew,
		ddsd.dwWidth, ddsd.dwHeight, //image dimensions
		loadTo, make3D, //memLocation, make3D
		pImageSource->isAnimated,
		pImageSource->frameWidth, pImageSource->frameHeight,
		pImageSource->firstFrame, pImageSource->frameCount);

	return((unsigned int) pImageNew);//return pointer pImageNew
}


//-----------------------------------------------------------------------------
// Name: CopyRectBB
// Desc: Copies a portion of one image to another, or to the current
//	drawing buffer
//-----------------------------------------------------------------------------
int CopyRectBB INTPARAMS
{
	int x1 = *in; in++;
	int y1 = *in; in++;
	int width = *in; in++;
	int height = *in; in++;
	int x2 = *in; in++;
	int y2 = *in; in++;

	//Get source image pointer
	LPDIRECTDRAWSURFACE7 pSourceImage=NULL;
	cImage* pImageSrc;
	unsigned int pointer = *in; in++;
	if (pointer == -1)
		pSourceImage = g_pCurrentSurface;
	else if (pointer == 1)
		pSourceImage = g_pFrontBuffer;
	else if (pointer == 2)
		pSourceImage = g_pBackBuffer;
	else
	{
	pImageSrc = (cImage*) pointer;//type cast to convert back to pointer	
 	if(pImageSrc == NULL) return -1;
	if(pImageSrc->pSurface == NULL) return -2;
	pSourceImage = pImageSrc->pSurface;
	}

	//Get destination image pointer
	LPDIRECTDRAWSURFACE7 pDestImage=NULL;
	cImage* pImageDest;
	pointer = *in; in++;
	if (pointer == -1)
		pDestImage = g_pCurrentSurface;
	else if (pointer == 1)
		pDestImage = g_pFrontBuffer;
	else if (pointer == 2)
		pDestImage = g_pBackBuffer;
	else
	{
	pImageDest = (cImage*) pointer;//type cast to convert back to pointer	
 	if(pImageDest == NULL) return -3;
	if(pImageDest->pSurface == NULL) return -4;
	pDestImage = pImageDest->pSurface;
	}

	//Figure out whether this will be a DirectX blit
	//or a slower Windows blit
	bool dxBlit = false;
	if (pDestImage == g_pFrontBuffer || 
		pDestImage == g_pBackBuffer)
	{
		if (pSourceImage == g_pFrontBuffer || 
			pSourceImage == g_pBackBuffer) 
			dxBlit = true;
		else if (pImageSrc->imageIs3D == false) 
			dxBlit = true;
	}
	else if (pImageDest->imageIs3D == false)
	{
		if (pSourceImage == g_pFrontBuffer || 
			pSourceImage == g_pBackBuffer) 
			dxBlit = true;
		else if (pImageSrc->imageIs3D == false) 
			dxBlit = true;
	}

	return BltImageSection (pSourceImage, pDestImage,
		x1, y1, x2, y2, width, height,
		DDBLT_WAIT, NULL, dxBlit);
}


//-----------------------------------------------------------------------------
// Name: CreateAlphaImageBB
// Desc: Creates an alpha-textured 3D-emaled image from two other images.
//-----------------------------------------------------------------------------
int CreateAlphaImageBB INTPARAMS
{
	//Get incoming info
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage1 = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage1 == NULL) return 0;

	pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage2 = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage2 == NULL) return 0;

	//Error Check: not supported in 8 or 24 bit screen mode
	if (g_screenDepth == 8 || g_screenDepth == 24) return 0; 

	//Error Check: return if dimensions are not the same.
	if (pImage1->imageWidth != pImage2->imageWidth || 
		pImage1->imageHeight != pImage2->imageHeight) return 0;

	//Set up the Direct Draw surface description for new image
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS       | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT       | //dwHeight member is valid
                 DDSD_WIDTH        | //dwWidth member is valid
                 DDSD_PIXELFORMAT  |
                 DDSD_TEXTURESTAGE;
	ddsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE; 
	ddsd.dwWidth = pImage1->imageWidth;
	ddsd.dwHeight = pImage1->imageHeight;
	
	//Use the TextureSearchCallback function to find the appropriate
	//alpha pixels image format.
	g_TextureSearchOption = 1;
	g_pD3DDevice->EnumTextureFormats( TextureSearchCallback, &ddsd.ddpfPixelFormat );
	g_TextureSearchOption = 0;
	if( 0L == ddsd.ddpfPixelFormat.dwRGBBitCount) return 0;

	//Apply alpha mask
	if (ddsd.ddpfPixelFormat.dwRGBBitCount == 16)
	{
	ddsd.ddpfPixelFormat.dwFlags = DDPF_RGB | DDPF_ALPHAPIXELS;
	ddsd.ddpfPixelFormat.dwRGBAlphaBitMask = 0x0000F000;
	ddsd.ddpfPixelFormat.dwRBitMask =        0x00000F00;
	ddsd.ddpfPixelFormat.dwGBitMask =        0x000000F0;
	ddsd.ddpfPixelFormat.dwBBitMask =        0x0000000F;
	}
	if (ddsd.ddpfPixelFormat.dwRGBBitCount == 32)
	{
	ddsd.ddpfPixelFormat.dwFlags = DDPF_RGB | DDPF_ALPHAPIXELS;
	ddsd.ddpfPixelFormat.dwRGBAlphaBitMask = 0xFF000000;
	ddsd.ddpfPixelFormat.dwRBitMask =        0x00FF0000;
	ddsd.ddpfPixelFormat.dwGBitMask =        0x0000FF00;
	ddsd.ddpfPixelFormat.dwBBitMask =        0x000000FF;
	}

	//Create the Direct Draw surface in specified memory area
	LPDIRECTDRAWSURFACE7 pSurface; //pointer to Direct Draw surface
	if (g_pDirectDraw->CreateSurface(
	&ddsd, //address of above DDSURFACEDESC2 structure that describes surface
	&pSurface, //address of the variable pointing to the surface
	NULL)  //advanced COM stuff
	!= DD_OK) return 0;

	//Copy the first image over to the new image
	HDC hdcSrc;
	HDC hdcDest;  //handle of display version of image
	if (pImage1->pSurface->GetDC(&hdcSrc) == DD_OK &&
		 pSurface->GetDC(&hdcDest) == DD_OK)
	{
		BOOL result = BitBlt(
			hdcDest,	// handle of destination DC
			0,		// x-coord of destination upper-left corner
			0,		// y-coord of destination upper-left corner
			pImage1->imageWidth, // width of destination rectangle
			pImage1->imageHeight, // height of destination rectangle
			hdcSrc,	// handle of source DC
			0, // x-coord of source upper-left corner
			0, // y-coord of source upper-left corner
			SRCCOPY );	// raster operation code
	}		
	pSurface->ReleaseDC(hdcDest);
	pImage1->pSurface->ReleaseDC(hdcSrc);

	//Now copy the alpha information from the second image.
	//Lock both surfaces
	DDSURFACEDESC2 ddsd1; //surface description data structure
	ZeroMemory(&ddsd1, sizeof(ddsd1));// zero-out the memory area
	ddsd1.dwSize = sizeof(ddsd1);
	HRESULT hr = pImage2->pSurface->Lock(
		NULL,//lock entire surface
		&ddsd1,  
		DDLOCK_WAIT | DDLOCK_NOSYSLOCK,                    
		NULL);
	if (hr != DD_OK) return 0;		
	int pitch1 = (int) ddsd1.lPitch; //get the pitch 

	DDSURFACEDESC2 ddsd2; //surface description data structure
	ZeroMemory(&ddsd2, sizeof(ddsd2));// zero-out the memory area
	ddsd2.dwSize = sizeof(ddsd2);
	hr = pSurface->Lock(
		NULL,//lock entire surface
		&ddsd2,  
		DDLOCK_WAIT | DDLOCK_NOSYSLOCK,                    
		NULL);
	if (hr != DD_OK) //couldn't lock surface so exit
	{
		pImage2->pSurface->Unlock(NULL);
		return 0;
	}
	int pitch2 = (int) ddsd2.lPitch; //get the pitch in bytes

	if (g_screenDepth == 16)
	{
	WORD r;
	short* pSurface1 = (short*) ddsd1.lpSurface; //Grab surface pointer
	short* pSurface2 = (short*) ddsd2.lpSurface; //Grab surface pointer

		if (g_screenFormat16Bit == 555)	{
		for (int x = 0; x < pImage1->imageWidth; x++){
		for (int y = 0; y < pImage1->imageHeight; y++){
		r = ((*(pSurface1+x+y*pitch2/2) >> 10) % 32); //read 5 bit red (10)
		r = (r/2) << 12;                 //convert 5 bit red to 4 bit alpha
		*(pSurface2+x+y*pitch2/2) = *(pSurface2+x+y*pitch2/2) | r;

		}}}
		if (g_screenFormat16Bit == 565)	{
		for (int x = 0; x < pImage1->imageWidth; x++){
		for (int y = 0; y < pImage1->imageHeight; y++){
		r = ((*(pSurface1+x+y*pitch2/2) >> 11) % 32); //read 5 bit red (11)
		r = (r/2) << 12;                 //convert 5 bit red to 4 bit alpha
		*(pSurface2+x+y*pitch2/2) = *(pSurface2+x+y*pitch2/2) | r;
		}}}

	}

	if (g_screenDepth == 32)
	{
	byte* pSurface1 = (byte*) ddsd1.lpSurface; //Grab surface pointer
	byte* pSurface2 = (byte*) ddsd2.lpSurface; //Grab surface pointer
	for (int x = 0; x < pImage1->imageWidth; x++){
		for (int y = 0; y < pImage1->imageHeight; y++){
		*(pSurface2+x*4+y*pitch1+3) = *(pSurface1+x*4+y*pitch2+2);
		}
	}
	}

	//Unlock both surfaces
	pSurface->Unlock(NULL);
	pImage2->pSurface->Unlock(NULL);

	//Create a new cImage class instance to hold image data 
	cImage* pImage = CreateCImage (pSurface,
		pImage1->imageWidth, pImage1->imageHeight, //image dimensions
		0, 1, false, //memLocation, make3D, isAnimated
		0,0,0,1); //frameWidth, frameHeight, firstFrame, frameCount
	pImage->pStats3D->isAlphaTextured = true;

	return((unsigned int) pImage);//return pointer pImage
}


//-----------------------------------------------------------------------------
// Name: CreateCImage
// Desc: Initializes a cImage image class container.
//  Called by CopyImageBB, CreateImageBB, LoadImageBB, and
//  Load3DImageBB.
//-----------------------------------------------------------------------------
cImage* CreateCImage (LPDIRECTDRAWSURFACE7 pSurface,
		int width, int height, 
		byte memLocation = 0, int make3D = 0,
		bool isAnimated = false,
		int frameWidth = 0, int frameHeight = 0, 
		int firstFrame = 0, int frameCount = 1)
{
	//Create a new cImage class instance to hold image data 
	cImage* pImage = new cImage;
	pImage->pSurface = pSurface; //pointer to the image
	pImage->imageWidth = width;
	pImage->imageHeight = height;

	//Image handle
	if (g_AutoMidHandle == false)
	{
	pImage->xHandle = 0;
	pImage->yHandle = 0;
	}
	else if (isAnimated == true)
	{
	pImage->xHandle = frameWidth/2;
	pImage->yHandle = frameHeight/2;
	}
	else if (isAnimated == false)
	{
	pImage->xHandle = width/2;
	pImage->yHandle = height/2;
	}

	//Memory location and 3D image info.
	pImage->memLocation = memLocation;
	if (make3D == 0)
	{
		pImage->imageIs3D = false;
		pImage->pStats3D = NULL;
	}
	else
	{
		pImage->imageIs3D = true;
		pImage->pStats3D = new cStats3D;
		pImage->pStats3D->isAlphaTextured = false;
		pImage->pStats3D->vertexAlphaUsed = false;
		pImage->pStats3D->vertexAlpha0 = 255;
		pImage->pStats3D->vertexAlpha1 = 255;
		pImage->pStats3D->vertexAlpha2 = 255;
		pImage->pStats3D->vertexAlpha3 = 255;
		pImage->pStats3D->vertexColor = RGB_MAKE(255,255,255);
		pImage->pStats3D->filter = 0; //0 = no filtering
	}

	//Image mask
	if (g_AutoMask == true)
	{
		pImage->isMasked = true;
		DDCOLORKEY ddck;
		ddck.dwColorSpaceLowValue = ColorMatch(pImage->pSurface, 
			g_AutoMaskColor,pImage->imageIs3D);
		ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
		pImage->convertedMaskColor = ddck.dwColorSpaceLowValue;
		pImage->pSurface->SetColorKey(DDCKEY_SRCBLT, &ddck);
	}
	else if (g_AutoMaskImagePixel == true)
	{
		if (g_AutoMaskX < pImage->imageWidth && 
			g_AutoMaskY < pImage->imageHeight) //don't mask to pixel
		{   //pixel that is outside of image.
		pImage->isMasked = true;
		DDCOLORKEY ddck;
		ddck.dwColorSpaceLowValue = ReadPixel (pImage, g_AutoMaskX,
			g_AutoMaskY,1);
		ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
		pImage->convertedMaskColor = ddck.dwColorSpaceLowValue;
		pImage->pSurface->SetColorKey(DDCKEY_SRCBLT, &ddck);
		}
	}
	else
	{
		pImage->isMasked = false;
		pImage->convertedMaskColor = 0;
	}

	//Animated image info
	if (isAnimated == false)
	{
		pImage->isAnimated = false; //if animated
		pImage->frameWidth = pImage->imageWidth;//if animated, width of frame
		pImage->frameHeight = pImage->imageHeight;//if animated, height of frame
		pImage->firstFrame = 0;//if animated, first frame
		pImage->frameCount = 1;//if animated, count of frames
		pImage->framesWide = 1;
	}
	else
	{
		pImage->isAnimated = true; //if animated
		pImage->frameWidth = frameWidth;//if animated, width of frame
		pImage->frameHeight = frameHeight;//if animated, height of frame
		pImage->firstFrame = firstFrame;//if animated, first frame
		pImage->frameCount = frameCount;//if animated, count of frames
		pImage->framesWide = pImage->imageWidth/frameWidth;
	}

	//Update linked list of images
	if (g_pFirstImage == NULL) g_pFirstImage = g_pLastImage = pImage;
	if (g_pFirstImage != pImage) 
	{
	g_pLastImage->nextImage = pImage;//link this item to end of list
	pImage->previousImage = g_pLastImage;//do a return link
	g_pLastImage = pImage;//make this item the last one on the list
	}

	return pImage;
}


//-----------------------------------------------------------------------------
// Name: CreateImageBB
// Desc: Creates an image of the specified dimensions, ready for 
//	writing or copying.
//-----------------------------------------------------------------------------
int CreateImageBB INTPARAMS
{
	int width = *in; in++; //width of image
	int height = *in; in++; //height of image
	int loadTo = *in; in++; //flag that says whether to create image in VRAM/RAM
	int make3D = *in; in++; //0 = normal image, 1 = make 3D image

	//Set up the Direct Draw surface description
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);
	if (make3D == 0)
	{
	ddsd.dwFlags = DDSD_CAPS | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT | //dwHeight member is valid
                 DDSD_WIDTH;   //dwWidth member is valid
	if (loadTo == 0) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN; 
	if (loadTo == 1) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN 
		| DDSCAPS_SYSTEMMEMORY; //load to RAM if loadTo == 1
	}
	else
	{
	ddsd.dwFlags = DDSD_CAPS       | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT       | //dwHeight member is valid
                 DDSD_WIDTH        | //dwWidth member is valid
                 DDSD_PIXELFORMAT  |
				 DDSD_TEXTURESTAGE | //it's a D3D texture
                 DDSD_CKSRCBLT;      //color key enabled
	ddsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE; 
	g_pD3DDevice->EnumTextureFormats( TextureSearchCallback, &ddsd.ddpfPixelFormat );
	if( 0L == ddsd.ddpfPixelFormat.dwRGBBitCount )
        return 0;
	}
	ddsd.dwWidth = width;
	ddsd.dwHeight = height;

	//Create the Direct Draw surface in specified memory area
	LPDIRECTDRAWSURFACE7 pSurface; //pointer to Direct Draw surface
	if (g_pDirectDraw->CreateSurface(
	&ddsd, //address of above DDSURFACEDESC2 structure that describes surface
	&pSurface, //address of the variable pointing to the surface
	NULL)  //advanced COM stuff
	!= DD_OK) return 0;

	//Fill the surface with the color black.
	DDBLTFX ddbltfx;
	ZeroMemory( &ddbltfx, sizeof(ddbltfx));
	ddbltfx.dwSize      = sizeof(ddbltfx);
	ddbltfx.dwFillColor = 0;
	HRESULT hr = pSurface->Blt(
		NULL, //destination rectangle of blit (0 = blit entire surface)
		NULL, //address of source surface blitted from (0 used here)
		NULL, //source rectangle of blit (0 = blit from entire surface)
		DDBLT_COLORFILL | DDBLT_WAIT, //blit flags; DDBLT_COLORFILL = use dwFillColor member
		// of the DDBLTFX structure as the RGB color that fills the destination
		&ddbltfx );//address of special effects ddbltfx structure created above

	//Create a new cImage class instance to hold image data 
	cImage* pImage = CreateCImage (pSurface,
		ddsd.dwWidth, ddsd.dwHeight, //image dimensions
		loadTo, make3D, //memLocation, make3D
		false); //isAnimated

	return((unsigned int) pImage);//return pointer pImage
}


//-----------------------------------------------------------------------------
// Name: Cull3DImagesBB
// Desc: Prevents a 3D image or portion of a 3D image from being drawn
// if it is facing away from the screen. Primarily used with the 
// Draw3DQuadBB command. The only affect on the Draw3DImage command is
// causing images drawn flipped to not be drawn at all.
//-----------------------------------------------------------------------------
int Cull3DImagesBB INTPARAMS
{
	//Get incoming info
	int value = *in;
	if (value == TRUE)
		g_pD3DDevice->SetRenderState(D3DRENDERSTATE_CULLMODE,D3DCULL_CCW);
	else
		g_pD3DDevice->SetRenderState(D3DRENDERSTATE_CULLMODE,D3DCULL_NONE);
	return 1;
} 


//-----------------------------------------------------------------------------
// Name: Draw3DImage
// Desc: This function processes alpha and texture blending for 3D 
// images and then draws the processed image on scree. It is used
// by the Draw3DImageBB, Draw3DImageUL, Draw3DQuadBB, and Draw3DQuadUL
// functions.
//-----------------------------------------------------------------------------
int Draw3DImage(cImage* pImage, int alpha)
{
	//Color key the image, if applicable
	if (pImage->isMasked == true)
		g_pD3DDevice->SetRenderState(D3DRENDERSTATE_COLORKEYENABLE, TRUE);
	else
		g_pD3DDevice->SetRenderState(D3DRENDERSTATE_COLORKEYENABLE, FALSE);

	//Figure out alpha-blending
	if (alpha != 255 || pImage->pStats3D->isAlphaTextured == true || 
		pImage->pStats3D->vertexAlphaUsed == true)
	{
		g_pD3DDevice->SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE,true);
		if (alpha != -100) //if image is alpha blended
		{
		    g_pD3DDevice->SetRenderState(D3DRENDERSTATE_SRCBLEND,D3DBLEND_SRCALPHA);//D3DBLEND_SRCCOLOR //D3DBLEND_SRCALPHA
		    g_pD3DDevice->SetRenderState(D3DRENDERSTATE_DESTBLEND,D3DBLEND_INVSRCALPHA);//D3DBLEND_INVSRCALPHA //D3DBLEND_INVSRCCOLOR	 
		}
		else  //if image is additive blended
		{
		    g_pD3DDevice->SetRenderState(D3DRENDERSTATE_SRCBLEND,D3DBLEND_ONE);
		    g_pD3DDevice->SetRenderState(D3DRENDERSTATE_DESTBLEND,D3DBLEND_ONE);	 
		}
		if (pImage->pStats3D->isAlphaTextured == true)
			g_pD3DDevice->SetTextureStageState(0,D3DTSS_ALPHAOP,D3DTOP_SELECTARG1);	
 		else
			g_pD3DDevice->SetTextureStageState(0,D3DTSS_ALPHAOP,D3DTA_TFACTOR); 
	}
	else
	{
		g_pD3DDevice->SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE,false);
	}

	//Vertex Alpha
	if (pImage->pStats3D->vertexAlphaUsed == true)
	{
	g_Vertex[0].color = pImage->pStats3D->vertexColor | 
		(pImage->pStats3D->vertexAlpha0 << 24);
	g_Vertex[1].color = pImage->pStats3D->vertexColor | 
		(pImage->pStats3D->vertexAlpha1 << 24);
	g_Vertex[2].color = pImage->pStats3D->vertexColor | 
		(pImage->pStats3D->vertexAlpha2 << 24);
	g_Vertex[3].color = pImage->pStats3D->vertexColor | 
		(pImage->pStats3D->vertexAlpha3 << 24);
	}
	else
	{
	g_Vertex[0].color = pImage->pStats3D->vertexColor | (alpha << 24);
	g_Vertex[1].color = g_Vertex[0].color;
	g_Vertex[2].color = g_Vertex[0].color;
	g_Vertex[3].color = g_Vertex[0].color;
	}

	//Set filtering
	if (pImage->pStats3D->filter == 1)
	{
	g_pD3DDevice->SetTextureStageState(0,D3DTSS_MINFILTER,D3DTFG_LINEAR); 
	g_pD3DDevice->SetTextureStageState(0,D3DTSS_MAGFILTER,D3DTFG_LINEAR); 
	}

	//Set texture
	g_pD3DDevice->SetTexture(0,pImage->pSurface);

	// Begin the scene
	if(FAILED(g_pD3DDevice->BeginScene())) return -1;

	//Render the quad
	 g_pD3DDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,
		D3DFVF_TLVERTEX, g_Vertex, 4, 0);

	//Free the texture from the 3D device, thereby avoiding memory leaks
	g_pD3DDevice->SetTexture(0,NULL);

	// End the scene.
	g_pD3DDevice->EndScene();

	//Reset to nearest-point sampling for filtering
	if (pImage->pStats3D->filter != 0)
	{
	g_pD3DDevice->SetTextureStageState(0,D3DTSS_MINFILTER,D3DTFG_POINT); 
	g_pD3DDevice->SetTextureStageState(0,D3DTSS_MAGFILTER,D3DTFG_POINT); 
	}
	return 1;
}


//-----------------------------------------------------------------------------
// Name: Draw3DImageBB()
// Desc: Draws a 3D-enabled image, which supports real-time rotations, scaling
//	and alpha blending. Not currently supported in 8 bit (paletted) or 24 bit 
//	display mode.
//-----------------------------------------------------------------------------
int Draw3DImageBB INTPARAMS
{
	//Not supported in 8 or 24 bit screen mode
	if (g_screenDepth == 8 || g_screenDepth == 24) return 0; 

	//Get incoming info
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;
	int x1 = *in; in++; //x position to draw image
	int y1 = *in; in++;//y position to draw image
	int alpha = *in; in++;
	int xScale = *in; in++; 
	int yScale = *in; in++; 
	if ((alpha <= 0 && alpha != -100) 
		|| xScale <= 0 || yScale <= 0) return 1;//don't draw invisible images
	int angle = *in; in++;
	int flipped = *in; in++;

	//Adjust handle according to scale used
	int x = x1-(pImage->xHandle*xScale/100);
	int y = y1-(pImage->yHandle*yScale/100);

	//Set location of 3D image by adjusting image vertices
	if (xScale == 100 && yScale == 100 && angle == 0 && flipped == 0) //simple (no effects)
	{
		    g_Vertex[0].sx = (float) x;
		    g_Vertex[0].sy = (float) y;

		    g_Vertex[1].sx = (float) x+pImage->imageWidth;
		    g_Vertex[1].sy = (float) y;

		    g_Vertex[2].sx = (float) x;
		    g_Vertex[2].sy = (float) y+pImage->imageHeight;

		    g_Vertex[3].sx = (float) x+pImage->imageWidth;
		    g_Vertex[3].sy = (float) y+pImage->imageHeight;
	}

	else if (flipped == 0) //if it is not flipped
	{
	    //This rotation method avoids the D3D T&L pipeline. We do our own 
	    //transformations and send the transformed vertices to the video card.
	    int xRadius = pImage->imageWidth*xScale/200;
	    int yRadius = pImage->imageHeight*yScale/200;
	    int midPointX = x+(pImage->imageWidth*xScale/200);
	    int midPointY = y+(pImage->imageHeight*yScale/200);
	    double multiple = 3.14159265/180;

	    g_Vertex[0].sx = (float) (midPointX+1.41421*cos((135+angle)*multiple)*xRadius);
	    g_Vertex[0].sy = (float) (midPointY-1.41421*sin((135+angle)*multiple)*yRadius);

	    g_Vertex[1].sx = (float) (midPointX+1.41421*cos((45+angle)*multiple)*xRadius);
	    g_Vertex[1].sy = (float) (midPointY-1.41421*sin((45+angle)*multiple)*yRadius);

	    g_Vertex[2].sx = (float) (midPointX+1.41421*cos((225+angle)*multiple)*xRadius);
	    g_Vertex[2].sy = (float) (midPointY-1.41421*sin((225+angle)*multiple)*yRadius);

	    g_Vertex[3].sx = (float) (midPointX+1.41421*cos((315+angle)*multiple)*xRadius);
	    g_Vertex[3].sy = (float) (midPointY-1.41421*sin((315+angle)*multiple)*yRadius);
	}

	else //if image is flipped
	{
		if (xScale == 100 && yScale == 100 && angle == 0) //if it is not rotated or scaled
		{		
			g_Vertex[0].sx = (float) x+pImage->imageWidth;
		    g_Vertex[0].sy = (float) y;

		    g_Vertex[1].sx = (float) x;
		    g_Vertex[1].sy = (float) y;

		    g_Vertex[2].sx = (float) x+pImage->imageWidth;
		    g_Vertex[2].sy = (float) y+pImage->imageHeight;

		    g_Vertex[3].sx = (float) x;
		    g_Vertex[3].sy = (float) y+pImage->imageHeight;
		}

		else //if it is rotated and/or scaled
		{
		    //This rotation method avoids the D3D T&L pipeline. We do our own 
		    //transformations and send the transformed vertices to the video card.
		    int xRadius = pImage->imageWidth*xScale/200;
		    int yRadius = pImage->imageHeight*yScale/200;
		    int midPointX = x+(pImage->imageWidth*xScale/200);
		    int midPointY = y+(pImage->imageHeight*yScale/200);
		    double multiple = 3.14159265/180;

		    g_Vertex[0].sx = (float) (midPointX+1.41421*cos((315+angle)*multiple)*xRadius);
		    g_Vertex[0].sy = (float) (midPointY-1.41421*sin((135+angle)*multiple)*yRadius);

		    g_Vertex[1].sx = (float) (midPointX+1.41421*cos((225+angle)*multiple)*xRadius);
		    g_Vertex[1].sy = (float) (midPointY-1.41421*sin((45+angle)*multiple)*yRadius);

		    g_Vertex[2].sx = (float) (midPointX+1.41421*cos((45+angle)*multiple)*xRadius);
		    g_Vertex[2].sy = (float) (midPointY-1.41421*sin((225+angle)*multiple)*yRadius);

		    g_Vertex[3].sx = (float) (midPointX+1.41421*cos((135+angle)*multiple)*xRadius);
		    g_Vertex[3].sy = (float) (midPointY-1.41421*sin((315+angle)*multiple)*yRadius);
		}
	}

	return Draw3DImage(pImage, alpha);
}


//-----------------------------------------------------------------------------
// Name: Draw3DImageUL (userlib version)
// Desc: Similar to Draw3DImageBB, except that you specify the corner
// coordinates. Handle information is ignored with this command.
//-----------------------------------------------------------------------------
BBDECL int BBCALL Draw3DImageUL (UINT pointer, int x1, int y1, 
	int alpha, int xScale, int yScale, int angle, int flipped)
{
	//Not supported in 8 or 24 bit screen mode
	if (g_screenDepth == 8 || g_screenDepth == 24) return 0; 

	//Error Check
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;
	if ((alpha <= 0 && alpha != -100) 
		|| xScale <= 0 || yScale <= 0) return 1;//don't draw invisible images

	//Adjust handle according to scale used
	int x = x1-(pImage->xHandle*xScale/100);
	int y = y1-(pImage->yHandle*yScale/100);

	//Set location of 3D image by adjusting image vertices
	if (xScale == 100 && yScale == 100 && angle == 0 && flipped == 0) //simple (no effects)
	{
		    g_Vertex[0].sx = (float) x;
		    g_Vertex[0].sy = (float) y;

		    g_Vertex[1].sx = (float) x+pImage->imageWidth;
		    g_Vertex[1].sy = (float) y;

		    g_Vertex[2].sx = (float) x;
		    g_Vertex[2].sy = (float) y+pImage->imageHeight;

		    g_Vertex[3].sx = (float) x+pImage->imageWidth;
		    g_Vertex[3].sy = (float) y+pImage->imageHeight;
	}

	else if (flipped == 0) //if it is not flipped
	{
	    //This rotation method avoids the D3D T&L pipeline. We do our own 
	    //transformations and send the transformed vertices to the video card.
	    int xRadius = pImage->imageWidth*xScale/200;
	    int yRadius = pImage->imageHeight*yScale/200;
	    int midPointX = x+(pImage->imageWidth*xScale/200);
	    int midPointY = y+(pImage->imageHeight*yScale/200);
	    double multiple = 3.14159265/180;

	    g_Vertex[0].sx = (float) (midPointX+1.41421*cos((135+angle)*multiple)*xRadius);
	    g_Vertex[0].sy = (float) (midPointY-1.41421*sin((135+angle)*multiple)*yRadius);

	    g_Vertex[1].sx = (float) (midPointX+1.41421*cos((45+angle)*multiple)*xRadius);
	    g_Vertex[1].sy = (float) (midPointY-1.41421*sin((45+angle)*multiple)*yRadius);

	    g_Vertex[2].sx = (float) (midPointX+1.41421*cos((225+angle)*multiple)*xRadius);
	    g_Vertex[2].sy = (float) (midPointY-1.41421*sin((225+angle)*multiple)*yRadius);

	    g_Vertex[3].sx = (float) (midPointX+1.41421*cos((315+angle)*multiple)*xRadius);
	    g_Vertex[3].sy = (float) (midPointY-1.41421*sin((315+angle)*multiple)*yRadius);
	}

	else //if image is flipped
	{
		if (xScale == 100 && yScale == 100 && angle == 0) //if it is not rotated or scaled
		{		
			g_Vertex[0].sx = (float) x+pImage->imageWidth;
		    g_Vertex[0].sy = (float) y;

		    g_Vertex[1].sx = (float) x;
		    g_Vertex[1].sy = (float) y;

		    g_Vertex[2].sx = (float) x+pImage->imageWidth;
		    g_Vertex[2].sy = (float) y+pImage->imageHeight;

		    g_Vertex[3].sx = (float) x;
		    g_Vertex[3].sy = (float) y+pImage->imageHeight;
		}

		else //if it is rotated and/or scaled
		{
		    //This rotation method avoids the D3D T&L pipeline. We do our own 
		    //transformations and send the transformed vertices to the video card.
		    int xRadius = pImage->imageWidth*xScale/200;
		    int yRadius = pImage->imageHeight*yScale/200;
		    int midPointX = x+(pImage->imageWidth*xScale/200);
		    int midPointY = y+(pImage->imageHeight*yScale/200);
		    double multiple = 3.14159265/180;

		    g_Vertex[0].sx = (float) (midPointX+1.41421*cos((315+angle)*multiple)*xRadius);
		    g_Vertex[0].sy = (float) (midPointY-1.41421*sin((135+angle)*multiple)*yRadius);

		    g_Vertex[1].sx = (float) (midPointX+1.41421*cos((225+angle)*multiple)*xRadius);
		    g_Vertex[1].sy = (float) (midPointY-1.41421*sin((45+angle)*multiple)*yRadius);

		    g_Vertex[2].sx = (float) (midPointX+1.41421*cos((45+angle)*multiple)*xRadius);
		    g_Vertex[2].sy = (float) (midPointY-1.41421*sin((225+angle)*multiple)*yRadius);

		    g_Vertex[3].sx = (float) (midPointX+1.41421*cos((135+angle)*multiple)*xRadius);
		    g_Vertex[3].sy = (float) (midPointY-1.41421*sin((315+angle)*multiple)*yRadius);
		}
	}

	return Draw3DImage(pImage, alpha);
}


//-----------------------------------------------------------------------------
// Name: Draw3DQuadBB()
// Desc: Similar to Draw3DImageBB, except that you specify the corner
// coordinates. Handle information is ignored with this command.
//-----------------------------------------------------------------------------
int Draw3DQuadBB INTPARAMS
{
	//Not supported in 8 or 24 bit screen mode
	if (g_screenDepth == 8 || g_screenDepth == 24) return 0; 

	//Get incoming info
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;
	int x1 = *in; in++; //x position to draw image
	int y1 = *in; in++; //y position to draw image
	int x2 = *in; in++; //x position to draw image
	int y2 = *in; in++; //y position to draw image
	int x3 = *in; in++; //x position to draw image
	int y3 = *in; in++; //y position to draw image
	int x4 = *in; in++; //x position to draw image
	int y4 = *in; in++; //y position to draw image
	int alpha = *in; in++;
	if (alpha <= 0 && alpha != -100) return 1;//don't draw invisible images

	//Set the vertices
	g_Vertex[0].sx = (float) x1;
	g_Vertex[0].sy = (float) y1;

	g_Vertex[1].sx = (float) x2;
	g_Vertex[1].sy = (float) y2;

	g_Vertex[2].sx = (float) x4;
	g_Vertex[2].sy = (float) y4;

	g_Vertex[3].sx = (float) x3;
	g_Vertex[3].sy = (float) y3;

	return Draw3DImage(pImage, alpha);
}



//-----------------------------------------------------------------------------
// Name: Draw3DQuadUL (userlib version)
// Desc: Similar to Draw3DImageBB, except that you specify the corner
// coordinates. Handle information is ignored with this command.
//-----------------------------------------------------------------------------
BBDECL int BBCALL Draw3DQuadUL (UINT pointer, int x1, int y1, 
	int x2, int y2, int x3, int y3, int x4, int y4, int alpha)
{
	//Not supported in 8 or 24 bit screen mode
	if (g_screenDepth == 8 || g_screenDepth == 24) return 0; 

	//Get incoming info
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;
	if (alpha <= 0 && alpha != -100) return 1;//don't draw invisible images

	//Set the vertices
	g_Vertex[0].sx = (float) x1;
	g_Vertex[0].sy = (float) y1;

	g_Vertex[1].sx = (float) x2;
	g_Vertex[1].sy = (float) y2;

	g_Vertex[2].sx = (float) x4;
	g_Vertex[2].sy = (float) y4;

	g_Vertex[3].sx = (float) x3;
	g_Vertex[3].sy = (float) y3;

	return Draw3DImage(pImage, alpha);
}


//-----------------------------------------------------------------------------
// Name: DrawBlockBB
// Desc: This function blits an unmasked version of an image on the screen
//-----------------------------------------------------------------------------
int DrawBlockBB STDPARAMS
{
	//Get incoming info
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;
	int x = *in-pImage->xHandle; in++; //x position to draw image
	int y = *in-pImage->yHandle; in++; //y position to draw image
	int frame = *in; in++; //if animated

	//Draw the image
	return BltImage(pImage, x, y, frame, DDBLT_WAIT, NULL);
}


//-----------------------------------------------------------------------------
// Name: DrawBlockUL (userlib version)
// Desc: This function blits an unmasked version of an image on the screen
//-----------------------------------------------------------------------------
BBDECL int BBCALL DrawBlockUL (UINT pointer, int x, int y, int frame)
{
	//Error check
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;
	x = x-pImage->xHandle; //x position to draw image
	y = y-pImage->yHandle; //y position to draw image

	//Draw the image
	return BltImage(pImage, x, y, frame, DDBLT_WAIT, NULL);
}


//-----------------------------------------------------------------------------
// Name: DrawImageBB (CallDLL version)
// Desc: This function blits a masked image on the screen
//-----------------------------------------------------------------------------
int DrawImageBB STDPARAMS
{
	//Get incoming info
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;
	int x = *in-pImage->xHandle; in++; //x position to draw image
	int y = *in-pImage->yHandle; in++; //y position to draw image
	int frame = *in; in++; //if animated

	//Draw the image
	if (pImage->isMasked == false)
	{
		return BltImage(pImage, x, y, frame, DDBLT_WAIT, NULL);
	}
	else
	{
		return BltImage(pImage, x, y, frame, 
			DDBLT_KEYSRC | DDBLT_WAIT, NULL);
	}
}


//-----------------------------------------------------------------------------
// Name: DrawImageUL (userlib version)
// Desc: This function blits a masked image on the screen
//-----------------------------------------------------------------------------
BBDECL int BBCALL DrawImageUL (UINT pointer, int x, int y, int frame)
{
	//Error check
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;
	x = x-pImage->xHandle; //x position to draw image
	y = y-pImage->yHandle; //y position to draw image

	//Draw the image
	if (pImage->isMasked == false)
	{
		return BltImage(pImage, x, y, frame, DDBLT_WAIT, NULL);
	}
	else
	{
		return BltImage(pImage, x, y, frame, 
			DDBLT_KEYSRC | DDBLT_WAIT, NULL);
	}
}


//-----------------------------------------------------------------------------
// Name: DrawImageRectBB
// Desc: Draws a portion of an image to the current buffer. If the original
//	is masked, this will be too. Handle information is ignored.
//-----------------------------------------------------------------------------
int DrawImageRectBB INTPARAMS
{
	//Get incoming info
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return -1;
	if(pImage->pSurface == NULL) return -1;
	int x2 = *in; in++;
	int y2 = *in; in++;
	int x1 = *in; in++;
	int y1 = *in; in++;
	int width = *in; in++;
	int height = *in;

	bool dxBlit = false;
	if (g_pCurrentBuffer != 3)
	{
		if (pImage->imageIs3D == false) dxBlit = true;
	}
	else if (g_pCurrentImage->imageIs3D == false)
	{
		if (pImage->imageIs3D == false) dxBlit = true;
	}

	//Draw section of the image
	if (pImage->isMasked == false)
		return BltImageSection (pImage->pSurface, g_pCurrentSurface,
			x1, y1, x2, y2, width, height,
			DDBLT_WAIT, NULL, dxBlit);
	else
		return BltImageSection (pImage->pSurface, g_pCurrentSurface,
			x1, y1, x2, y2, width, height,
			DDBLT_KEYSRC | DDBLT_WAIT, NULL, dxBlit);
}


//-----------------------------------------------------------------------------
// Name: EndGraphicsBB
// Desc: Releases all Direct Draw objects.
//-----------------------------------------------------------------------------
int EndGraphicsBB STDPARAMS
{
	return ReleaseObjectsBB();
}


//-----------------------------------------------------------------------------
// Name: Filter3DImageBB
// Desc: Turns on filtering for a 3D-enabled image. 
//-----------------------------------------------------------------------------
int Filter3DImageBB INTPARAMS
{
	//Get incoming info
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;

	pImage->pStats3D->filter = *in;
	return 1;
}


//-----------------------------------------------------------------------------
// Name: FlipBB
// Desc: This function flips stuff drawn on the back buffer to the front buffer
//-----------------------------------------------------------------------------
int FlipBB STDPARAMS
{
	HRESULT                     hr;
	while (TRUE)
	{
        hr = g_pFrontBuffer->Flip(NULL, 0);
        if (hr == DD_OK) //if flip was successful
		{
			//Freeze the Windows mouse to make sure it does not do 
			//anything like inadvertantly minimize the game. This is
			//only necessary because of the kind of Window Blitz is using.
			//A popup window, which is normally used with DirectX, wouldn't
			//need this. But the default Blitz window wasn't originally
			//designed for the kind of things we are doing with this dll.
			//This isn't necessary when using Blitz Plus, however.
			if (g_UseBlitzMouse == false) SetCursorPos(200,200);
			break;
		}
        if (hr == DDERR_SURFACELOST) //if surface has been lost
        {
            hr = g_pDirectDraw->RestoreAllSurfaces(); //Reload images
            if (hr != DD_OK) break; 
			hr = g_pMouse->Acquire(); //reaquire mouse for Direct Input
			ShowCursor(FALSE);
			g_CurrentMouseX = g_screenWidth/2;
			g_CurrentMouseY = g_screenHeight/2;
        }
        if (hr != DDERR_WASSTILLDRAWING)
            break;
	}
	if (hr == DD_OK) return 1;
	return 0;
}



//-----------------------------------------------------------------------------
// Name: FlipImageBB
// Desc: This function flips an image horizontally, vertically, or both.
//	Unlike DrawFlipped, which draws a flipped version of the original
//	image on screen, this function flips the original image itself.
//-----------------------------------------------------------------------------
int FlipImageBB INTPARAMS
{
	//Get incoming info
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //can't flip front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;	
	if(pImage->imageIs3D == true) return 0; //can't flip 3D image
	int mode = *in; //mode to draw image (0 = horizontal, 1 = vertical, 2 = both)
	char loadTo = pImage->memLocation;

	//Create a temporary image to copy flipped image to
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT | //dwHeight member is valid
                 DDSD_WIDTH;   //dwWidth member is valid
	if (loadTo == 0) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN; 
	if (loadTo == 1) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN 
		| DDSCAPS_SYSTEMMEMORY; //load to RAM if loadTo == 1
	ddsd.dwWidth = pImage->imageWidth;
	ddsd.dwHeight = pImage->imageHeight;
	LPDIRECTDRAWSURFACE7 pTempImage; //pointer to Direct Draw surface
	HRESULT hr = g_pDirectDraw->CreateSurface(
	&ddsd, //address of above DDSURFACEDESC2 structure that describes surface
	&pTempImage, //address of the variable pointing to the new image
	NULL);  //advanced COM stuff
	if (hr != DD_OK) return hr;

	//Set up Mirrored Blit stuff
	int effect = 0;
	if (mode == 0) effect = DDBLTFX_MIRRORLEFTRIGHT;
	if (mode == 1) effect = DDBLTFX_MIRRORUPDOWN;
	if (mode == 2) effect = DDBLTFX_MIRRORLEFTRIGHT | DDBLTFX_MIRRORUPDOWN;
	DDBLTFX  ddbltfx;  
	ZeroMemory(&ddbltfx, sizeof(ddbltfx));
	ddbltfx.dwSize = sizeof(ddbltfx);
	ddbltfx.dwDDFX = effect;

	//Compute destination rectangle
	RECT rectDest;
	rectDest.left=0;
	rectDest.right=pImage->imageWidth;
	rectDest.top=0;
	rectDest.bottom=pImage->imageHeight;

	//Blit it to the temporary image
	pTempImage->Blt(
	    &rectDest, //Destination RECT
		pImage->pSurface,  //lpDDSrcSurface
	    NULL, //Source RECT or NULL for entire surface
	    DDBLT_WAIT | DDBLT_DDFX,//flags
	    &ddbltfx ); //special effects

	//Now delete the original image and put the new image
	//in its place
	pImage->pSurface->Release();
	pImage->pSurface = pTempImage;

	//If appropriate, mask the new image the same as the original
	if (pImage->isMasked == true)
	{
	DDCOLORKEY ddck;
	ddck.dwColorSpaceLowValue = pImage->convertedMaskColor;
	ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
	pImage->pSurface->SetColorKey(DDCKEY_SRCBLT, &ddck);
	}

	return 1;
}


//-----------------------------------------------------------------------------
// Name: FreeAllImages
// Desc: Releases all DirectX surfaces
//-----------------------------------------------------------------------------
int FreeAllImages(void)
{
	int imageCount = 0;//number of images freed
	cImage* pImage = g_pFirstImage;
	while(pImage != NULL)
	{
	imageCount = imageCount + 1;//keep track of images deleted
	cImage* pTemp = pImage->nextImage;
	if (pImage->pSurface != NULL) pImage->pSurface->Release();//release VRAM
	if (pImage->pStats3D != NULL) delete pImage->pStats3D;
	delete pImage; //delete its container object
	pImage = pTemp;
	}
	g_pFirstImage = NULL;
	g_pLastImage = NULL;
	return imageCount;
}


//-----------------------------------------------------------------------------
// Name: FreeAllImagesBB
// Desc: Releases a bitmap
//-----------------------------------------------------------------------------
int FreeAllImagesBB INTPARAMS
{
	return FreeAllImages();
}


//-----------------------------------------------------------------------------
// Name: FreeImageBB 
// Desc: Frees the VRAM associated with a previously created image.
//  The command does not delete the image's container class, however, which 
//  consumes only a few bytes of memory. This provides a certain level of
//  error protection against subsequent DrawImage calls using
//  a pointer to an image that no longer exists. If a DrawImage or
//  similar command is called on an image that no longer exists,
//  it will do nothing. Unfortunately, this does not protect against
//  DrawImage calls on images that were never created in the first 
//  place.
//-----------------------------------------------------------------------------
int FreeImageBB STDPARAMS
{
	//Get and translate the image pointer
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;

	//If for some reason this image was the current buffer, reset
	//the current buffer to the backbuffer.
	if (pImage->pSurface == g_pCurrentSurface)
	{
		g_pCurrentBuffer = 2;
		g_pCurrentImage = NULL;//pointer to the cImage in buffer
		g_pCurrentSurface = g_pBackBuffer;//pointer to the surface in buffer
	}

	//Release the image associated with this class pointer
	pImage->pSurface->Release();//release VRAM
	pImage->pSurface = NULL;//set pointer to NULL

	return DD_OK;
}


//-----------------------------------------------------------------------------
// Name: FrontBufferBB
// Desc: Returns a "pointer" to the front buffer.
//-----------------------------------------------------------------------------
int FrontBufferBB INTPARAMS
{
	return 1;
}


//-----------------------------------------------------------------------------
// Name: Get16BitFormatBB
// Desc: Returns the particular 16 bit format used when in 16 bit mode
//	This command is called from the GraphicsBB function in the include
//	file.
//-----------------------------------------------------------------------------
int Get16BitFormatBB INTPARAMS
{ 	
	return g_screenFormat16Bit;
}


//-----------------------------------------------------------------------------
// Name: GetMouseSpeedBB
// Desc: Returns the current mouse speed. This number does not correlate
//	with Windows system mouse speed values.
//-----------------------------------------------------------------------------
int GetMouseSpeedBB INTPARAMS
{ 	
	return g_MouseSpeed;
}


//-----------------------------------------------------------------------------
// Name: GetValueBB
// Desc: Returns a value. Used for testing purposes, this is good for
//	getting the current value of various globals or DirectX constants. 
//-----------------------------------------------------------------------------
int GetValueBB STDPARAMS
{ 	
	unsigned int getValue = *in;
	if (getValue==0) return g_Test;
	if (getValue==1) return g_Test1;
	if (getValue==2) return g_Test2;
	if (getValue==3) return g_Test3;
	if (getValue==4) return g_Test4;
	if (getValue==5) return g_Test5;
	if (getValue==6) return 0;

//	if (getValue==7) return DDBD_8;
//	if (getValue==8) return DDBD_16;
//	if (getValue==9) return DDBD_24;
//	if (getValue==10) return DDBD_32;
//	LPD3DDEVICEDESC7 lpD3DDevDesc;
//	g_pD3DDevice->GetCaps(lpD3DDevDesc);	
//	if (getValue==20) return lpD3DDevDesc->dwDeviceRenderBitDepth;
	
	cImage* pImage = (cImage*) getValue;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;
	return pImage->convertedMaskColor;
	if (pImage->isMasked == false) return -10;
	if (pImage->isMasked == true) return -11;
	return (pImage->xHandle);
}


//-----------------------------------------------------------------------------
// Name: GetVersionBB
// Desc: Returns the current version number 
//-----------------------------------------------------------------------------
int GetVersionBB INTPARAMS
{ 	
	return VERSION;
}


//-----------------------------------------------------------------------------
// Name: GraphicsBB 
// Desc: Creates an instance of Direct Draw.
//-----------------------------------------------------------------------------
int GraphicsBB STDPARAMS
{
	//Get incoming info.
	g_screenWidth = *in; in = in+1;
	g_screenHeight = *in; in = in+1;
	g_screenDepth = *in; in = in+1;
	char* pWindowTitle = (char*) in;//parent application window title
	char* pPalleteFile = (char*) in+strlen(pWindowTitle)+1;

	//Create the Direct Draw object. Use DirectDrawCreateEx to enable
	//3d stuff.
	HRESULT hr = DirectDrawCreateEx(
         NULL, //use the GUID of the active display
         (VOID**)&g_pDirectDraw,//address of variable representing Direct Draw object
         IID_IDirectDraw7,//Specify Direct Draw 7
         NULL); //Advanced COM stuff
	if (hr != DD_OK) return 2;

	//Set the cooperative level
	HWND hWnd = FindWindow(NULL,pWindowTitle);//get the handle of the window
	g_hWndGame = hWnd; //save this info globally for the debuglog
	hr = g_pDirectDraw->SetCooperativeLevel(
         hWnd, //handle of program's window
         DDSCL_ALLOWREBOOT | DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN);
	if (hr != DD_OK) {ReleaseObjectsBB();return (int) hWnd;}

	//Set the display mode
	hr = g_pDirectDraw->SetDisplayMode(
         g_screenWidth, g_screenHeight, //set screen width, height
         g_screenDepth,//set the screen bit depth (8,16,24,32)
         0, //screen refresh rate - set to 0 for hardware default rate
         0); //for rarely used standard VGA mode stuff
	if (hr != DD_OK) 
	{
		if (g_pDirectDraw != NULL)
		{
		g_pDirectDraw->Release();
		g_pDirectDraw = NULL;
		}
		return 4;
	}

	//Create the primary surface (frontbuffer)
	DDSURFACEDESC2              ddsd;
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
                          DDSCAPS_FLIP |
                          DDSCAPS_COMPLEX |
						  DDSCAPS_3DDEVICE;
	ddsd.dwBackBufferCount = 1;
	hr = g_pDirectDraw->CreateSurface(&ddsd, &g_pFrontBuffer, NULL);
	if (hr != DD_OK) {ReleaseObjectsBB();return 5;}

	//Create the backbuffer
	DDSCAPS2                    ddscaps;
	ZeroMemory(&ddscaps, sizeof(ddscaps));
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	hr = g_pFrontBuffer->GetAttachedSurface(&ddscaps,&g_pBackBuffer);
	if (hr != DD_OK) {ReleaseObjectsBB();return 6;}

	//Make the back buffer the current buffer.
	g_pCurrentBuffer = 2;
	g_pCurrentSurface = g_pBackBuffer;

	//If in 8 bit mode, set a palette
	if (g_screenDepth == 8)
	{
	LoadPalette(&g_pPalette,pPalleteFile);
	g_pFrontBuffer->SetPalette(g_pPalette);
	g_pBackBuffer->SetPalette(g_pPalette);
	}

	//If in 16 bit mode, save the screen format (555 or 565)
	if (g_screenDepth == 16)
	{
		DDSURFACEDESC2 ddsd2;
		ZeroMemory(&ddsd2, sizeof(ddsd2));
		ddsd2.dwSize = sizeof(ddsd2);
		hr = g_pFrontBuffer->GetSurfaceDesc(&ddsd2); 
		if (ddsd2.ddpfPixelFormat.dwGBitMask == 992) g_screenFormat16Bit = 555;//555 16 bit
		if (ddsd2.ddpfPixelFormat.dwGBitMask == 2016) g_screenFormat16Bit = 565;//565 16 bit
	}

	//Hide the Windows cursor
	ShowCursor(FALSE);

	//Set up Direct Input
	hr = DirectInputCreateEx(
	  GetModuleHandle(NULL),//HINSTANCE hinst,                  
	  DIRECTINPUT_VERSION,                  
	  IID_IDirectInput7,
	  (VOID**)&g_pDirectInput,  
	  NULL);
	if (hr != DD_OK) {ReleaseObjectsBB();return 11;}

	//Set up a Direct Input-enabled mouse
	hr = g_pDirectInput->CreateDeviceEx(
		GUID_SysMouse,// 
		IID_IDirectInputDevice7,
        (void**)&g_pMouse,
		NULL);
	if (hr != DD_OK) {ReleaseObjectsBB();return 12;}
	hr = g_pMouse->SetDataFormat(&c_dfDIMouse);
	if (hr != DD_OK) {ReleaseObjectsBB();return 13;}
	hr = g_pMouse->SetCooperativeLevel(hWnd,
               DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);
	if (hr != DD_OK) {ReleaseObjectsBB();return 14;}

	//Set up buffer for MouseHit()
	DIPROPDWORD dipdw; //device property header data structure
	dipdw.diph.dwSize       = sizeof(DIPROPDWORD);
	dipdw.diph.dwHeaderSize = sizeof(DIPROPHEADER);
	dipdw.diph.dwObj        = 0;
	dipdw.diph.dwHow        = DIPH_DEVICE;
	dipdw.dwData            = 10; //# of buffered data items
	hr = g_pMouse->SetProperty(DIPROP_BUFFERSIZE, &dipdw.diph);
	if (hr != DI_OK)
	{
	if (hr == DI_PROPNOEFFECT) 
		{ReleaseObjectsBB();return 15;}
	else
		{ReleaseObjectsBB();return hr;}
	}

	//Acquire the mouse
	hr = g_pMouse->Acquire();
	if (hr != DD_OK) {ReleaseObjectsBB();return 16;}
	g_CurrentMouseX = g_screenWidth/2;
	g_CurrentMouseY = g_screenHeight/2;

	//Disable Alt-Tab
	UINT nPreviousState=0;
	SystemParametersInfo (SPI_SETSCREENSAVERRUNNING, TRUE, 
		&nPreviousState, 0);

	//Initialize 3D stuff.
	return Graphics3D();
}


//-----------------------------------------------------------------------------
// Name: Graphics3D
// Desc: This internal function initializes the 3D aspects of the dll.
//-----------------------------------------------------------------------------
int Graphics3D (void)
{ 	
	//If not in 8 bit/24 bit mode, activate 3D mode for special effect
	//(fast rotations, alpha blending, etc.).
	if (g_screenDepth != 8 && g_screenDepth != 24)
	{

	//Query DirectDraw for access to Direct3D
	HRESULT hr = g_pDirectDraw->QueryInterface(IID_IDirect3D7,(VOID**)&g_pD3D);
	if(FAILED(hr)) {ReleaseObjectsBB();return 17;};

	//Create the D3D device using hardware
	hr = g_pD3D->CreateDevice(
		IID_IDirect3DHALDevice, 
		g_pBackBuffer, 
		&g_pD3DDevice);

	//If no hardware support, create the D3D device using sofware
	if(FAILED(hr))
	{
        hr = g_pD3D->CreateDevice( 
		IID_IDirect3DRGBDevice,//reportedly supported by all video cards 
		g_pBackBuffer,
		&g_pD3DDevice);
	    if(FAILED(hr)) {ReleaseObjectsBB();return 18;}
	}

	//Create the viewport
	D3DVIEWPORT7 vp = {0,0, g_screenWidth, g_screenHeight, 0.0f, 1.0f };
	hr = g_pD3DDevice->SetViewport(&vp);
	if(FAILED(hr)) {ReleaseObjectsBB();return 19;}

	//Initialize the global vertices that we use for all 3D images.
	//dvRHW (D3DVALUE)
	g_Vertex[0].rhw = 1.0f;
	g_Vertex[1].rhw = 1.0f;
	g_Vertex[2].rhw = 1.0f;
	g_Vertex[3].rhw = 1.0f;

	//Base dcColor (D3DCOLOR) -- alpha (last) value can be altered
	g_Vertex[0].color = RGBA_MAKE(255, 255, 255, 127);//RGBA
	g_Vertex[1].color = RGBA_MAKE(255, 255, 255, 127);
	g_Vertex[2].color = RGBA_MAKE(255, 255, 255, 127);
	g_Vertex[3].color = RGBA_MAKE(255, 255, 255, 127);

	//dcSpecular (D3DCOLOR) 
	g_Vertex[0].specular = D3DRGB(1.0,1.0,1.0);
	g_Vertex[1].specular = D3DRGB(1.0,1.0,1.0);
	g_Vertex[2].specular = D3DRGB(1.0,1.0,1.0);
	g_Vertex[3].specular = D3DRGB(1.0,1.0,1.0);

	//Texture alignment (D3DVALUE). Since we are using 2D
	//sprites, we don't change this.
	g_Vertex[0].tu = 0.0f; g_Vertex[0].tv = 0.0f;
	g_Vertex[1].tu = 1.0f; g_Vertex[1].tv = 0.0f;
	g_Vertex[2].tu = 0.0f; g_Vertex[2].tv = 1.0f;
	g_Vertex[3].tu = 1.0f; g_Vertex[3].tv = 1.0f;

	//Preset some render states that don't get changed.
	g_pD3DDevice->SetRenderState(D3DRENDERSTATE_CLIPPING,false);
	g_pD3DDevice->SetRenderState(D3DRENDERSTATE_LIGHTING,false);
	g_pD3DDevice->SetRenderState(D3DRENDERSTATE_CULLMODE,D3DCULL_NONE);
	g_pD3DDevice->SetTextureStageState(0,D3DTSS_ADDRESSU,D3DTADDRESS_CLAMP);
	g_pD3DDevice->SetTextureStageState(0,D3DTSS_ADDRESSV,D3DTADDRESS_CLAMP);	
	}//if (g_screenDepth != 8)
	return 1;
}


//-----------------------------------------------------------------------------
// Name: GraphicsBufferBB
// Desc: Returns the current buffer
//-----------------------------------------------------------------------------
int GraphicsBufferBB INTPARAMS
{ 	
	if (g_pCurrentBuffer != 3) return g_pCurrentBuffer;
	return (unsigned int) g_pCurrentImage; //return pointer pImage
}


//-----------------------------------------------------------------------------
// Name: HandleImageBB
// Desc: Sets a handle for an image.
//-----------------------------------------------------------------------------
int HandleImageBB INTPARAMS
{ 	
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return -1;
	if(pImage->pSurface == NULL) return -2;
	pImage->xHandle = *in; in++; //x handle
	pImage->yHandle = *in; //y handle
	return 1;
}


//-----------------------------------------------------------------------------
// Name: HidePointerBB
// Desc: Hides the Windows cursor (default = hidden)
//-----------------------------------------------------------------------------
void HidePointerBB INTPARAMS
{
	ShowCursor(FALSE);
}


//-----------------------------------------------------------------------------
// Name: ImageHeightBB
// Desc: Gets the width of a given image.
//-----------------------------------------------------------------------------
int ImageHeightBB STDPARAMS
{
	unsigned int pointer = *in;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	return (pImage->imageHeight);
}


//-----------------------------------------------------------------------------
// Name: ImagesCollideBB
// Desc: Checks to see if two images have collided. This command
//	considers pixel transparency, unlike ImagesOverlap, and it is a 
//	bit slower as a result. It is faster if at least the first of the
//	two images is stored in RAM.
//-----------------------------------------------------------------------------
int ImagesCollideBB INTPARAMS
{
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage1 = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage1 == NULL) return -1;
	int x1 = *in-pImage1->xHandle; in++;
	int y1 = *in-pImage1->yHandle; in++;
	int frame1 = *in; in++;

	pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage2 = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage2 == NULL) return -2;
	int x2 = *in-pImage2->xHandle; in++;
	int y2 = *in-pImage2->yHandle; in++;
	int frame2 = *in; in++;

	//Figure out whether there is a simple overlap
	int overlaps = 0;
	if (x2 < x1+pImage1->frameWidth){
		if (x2+pImage2->frameWidth > x1){
			if (y2 < y1+pImage1->frameHeight){
				if (y2+pImage2->frameHeight > y1){
				overlaps = 1;
	}}}}
	if (overlaps == 0) return 0; //if no overlap, no collision

	//If there is an overlap, figure out the corner coordinates,
	//width, and height of the collision box (cBox).
	RECT cbox;
	if (x1 > x2) cbox.left = x1;
	if (x1 <= x2) cbox.left = x2;
	if (x1 + pImage1->frameWidth <= x2 + pImage2->frameWidth ) 
		cbox.right = x1 + pImage1->frameWidth;
	if (x1 + pImage1->frameWidth > x2 + pImage2->frameWidth ) 
		cbox.right = x2 + pImage2->frameWidth;

	if (y1 > y2) cbox.top = y1;
	if (y1 <= y2) cbox.top = y2;
	if (y1 + pImage1->frameHeight <= y2 + pImage2->frameHeight ) 
		cbox.bottom = y1 + pImage1->frameHeight;
	if (y1 + pImage1->frameHeight > y2 + pImage2->frameHeight ) 
		cbox.bottom = y2 + pImage2->frameHeight;

	int width = cbox.right-cbox.left;
	int height = cbox.bottom-cbox.top;

	//Transform collision box coordinates to image-specific coordinates
	int a = abs(x1-cbox.left); //x location of collision box in image 1
	int b = abs(y1-cbox.top);  //y location of collision box in image 1
	int c = abs(x2-cbox.left); //x location of collision box in image 2
	int d = abs(y2-cbox.top);  //y location of collision box in image 2

	//Add offset for animated images
	if (pImage1->isAnimated == true)
	{
		int xFrame = (frame1-pImage1->firstFrame) % pImage1->framesWide;
		int yFrame = (frame1-pImage1->firstFrame)/pImage1->framesWide;
		int xOffset = xFrame*pImage1->frameWidth;
		int yOffset = yFrame*pImage1->frameHeight;
		a = a + xOffset;
		b = b + yOffset;
	}
	if (pImage2->isAnimated == true)
	{
		int xFrame = (frame2-pImage2->firstFrame) % pImage2->framesWide;
		int yFrame = (frame2-pImage2->firstFrame)/pImage2->framesWide;
		int xOffset = xFrame*pImage2->frameWidth;
		int yOffset = yFrame*pImage2->frameHeight;
		c = c + xOffset;
		d = d + yOffset;
	}

	//Start pixel reading by locking both surfaces
	DDSURFACEDESC2 ddsd1; //surface description data structure
	ZeroMemory(&ddsd1, sizeof(ddsd1));// zero-out the memory area
	ddsd1.dwSize = sizeof(ddsd1);
	HRESULT hr = pImage1->pSurface->Lock(
		NULL,//lock entire surface
		&ddsd1,  
		DDLOCK_WAIT | DDLOCK_NOSYSLOCK,                    
		NULL);
	if (hr != DD_OK) //couldn't lock surface so exit
		return -3;
	int pitch1 = (int) ddsd1.lPitch; //get the pitch 
	int bytesPerPixel1 = ddsd1.ddpfPixelFormat.dwRGBBitCount/8;

	DDSURFACEDESC2 ddsd2; //surface description data structure
	ZeroMemory(&ddsd2, sizeof(ddsd2));// zero-out the memory area
	ddsd2.dwSize = sizeof(ddsd2);
	hr = pImage2->pSurface->Lock(
		NULL,//lock entire surface
		&ddsd2,  
		DDLOCK_WAIT | DDLOCK_NOSYSLOCK,                    
		NULL);
	if (hr != DD_OK) //couldn't lock surface so exit
	{
		pImage1->pSurface->Unlock(NULL);
		return -4;
	}
	int pitch2 = (int) ddsd2.lPitch; //get the pitch in bytes
	int bytesPerPixel2 = ddsd2.ddpfPixelFormat.dwRGBBitCount/8;
	int collision = 0;

	//Now do pixel detection in the collision box
	if (g_screenDepth == 8){
	byte* pSurface1 = (byte*) ddsd1.lpSurface; //Grab surface pointer
	byte* pSurface2 = (byte*) ddsd2.lpSurface; //Grab surface pointer
	for (int x = 0; x < width; x++){
		for (int y = 0; y < height; y++){
		if (*(pSurface1 + a+x + (b+y)*pitch1) != 
			pImage1->convertedMaskColor){
		if (*(pSurface2 + c+x + (d+y)*pitch2) != 
			pImage2->convertedMaskColor){
			collision = 1;
			break;
		}//if (*(pSurface2
		if (collision == 1) break;
		}//if (*(pSurface1
		}//for (int y = 0; y < height; y++){
	}//for (int x = 0; x < width; x++){
	}//if (g_screenDepth == 8){

	if (g_screenDepth == 16){
	int x = 0; int y = 0;
	short* pSurface1 = (short*) ddsd1.lpSurface; //Grab surface pointer
	short* pSurface2 = (short*) ddsd2.lpSurface; //Grab surface pointer
	pitch1 = pitch1/2; //adjust pitch to short value
	pitch2 = pitch2/2; //adjust pitch to short value
	for (x = 0; x < width; x++){
		for (y = 0; y < height; y++){
		if (*(pSurface1 + a+x + (b+y)*pitch1) != 
			pImage1->convertedMaskColor){
		if (*(pSurface2 + c+x + (d+y)*pitch2) != 
			pImage2->convertedMaskColor){
			collision = 1;
			break;
		}//if (*(pSurface2
		if (collision == 1) break;
		}//if (*(pSurface1
		}//for (int y = 0; y < height; y++){
	}//for (int x = 0; x < width; x++){
	}//if (g_screenDepth == 16){

	if (g_screenDepth == 24){
	byte* pSurface1 = (byte*) ddsd1.lpSurface; //Grab surface pointer
	byte* pSurface2 = (byte*) ddsd2.lpSurface; //Grab surface pointer
	for (int x = 0; x < width; x++){
		for (int y = 0; y < height; y++){
		if ((*((int*) (pSurface1+3*(a+x)+(b+y)*pitch1)) & 0x00FFFFFF) != 
			pImage1->convertedMaskColor){
		if ((*((int*) (pSurface2+3*(c+x)+(d+y)*pitch2)) & 0x00FFFFFF) != 
			pImage2->convertedMaskColor){
			collision = 1;
			break;
		}//if (*(pSurface2
		if (collision == 1) break;
		}//if (*(pSurface1
		}//for (int y = 0; y < height; y++){
	}//for (int x = 0; x < width; x++){
	}//if (g_screenDepth == 24){

	if (g_screenDepth == 32){
	int* pSurface1 = (int*) ddsd1.lpSurface; //Grab surface pointer
	int* pSurface2 = (int*) ddsd2.lpSurface; //Grab surface pointer
	pitch1 = pitch1/4; //adjust pitch to short value
	pitch2 = pitch2/4; //adjust pitch to short value
	for (int x = 0; x < width; x++){
		for (int y = 0; y < height; y++){
		if (*(pSurface1 + a+x + (b+y)*pitch1) != 
			pImage1->convertedMaskColor){
		if (*(pSurface2 + c+x + (d+y)*pitch2) != 
			pImage2->convertedMaskColor){
			collision = 1;
			break;
		}//if (*(pSurface2
		if (collision == 1) break;
		}//if (*(pSurface1
		}//for (int y = 0; y < height; y++){
	}//for (int x = 0; x < width; x++){
	}//if (g_screenDepth == 32){

	//Unlock both surfaces
	pImage1->pSurface->Unlock(NULL);
	pImage2->pSurface->Unlock(NULL);

	return collision; //return collision status
}


//-----------------------------------------------------------------------------
// Name: ImagesOverlapBB
// Desc: Checks to see if two images overlap. This command does not
//	consider whether pixels are transparent or not.
//-----------------------------------------------------------------------------
int ImagesOverlapBB INTPARAMS
{
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage1 = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage1 == NULL) return -1;
	int x1 = *in-pImage1->xHandle; in++;
	int y1 = *in-pImage1->yHandle; in++;

	pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage2 = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage2 == NULL) return -2;
	int x2 = *in-pImage2->xHandle; in++;
	int y2 = *in-pImage2->yHandle; in++;

	int overlaps = 0;
	if (x2 < x1+pImage1->frameWidth){
		if (x2+pImage2->frameWidth > x1){
			if (y2 < y1+pImage1->frameHeight){
				if (y2+pImage2->frameHeight > y1){
				overlaps = 1;
	}}}}

	return overlaps;
}


//-----------------------------------------------------------------------------
// Name: ImageWidthBB
// Desc: Gets the width of a given image.
//-----------------------------------------------------------------------------
int ImageWidthBB STDPARAMS
{
	unsigned int pointer = *in;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	return(pImage->imageWidth);
}


//-----------------------------------------------------------------------------
// Name: ImageXHandleBB
// Desc: Returns x handle of an image
//-----------------------------------------------------------------------------
int ImageXHandleBB INTPARAMS
{ 	
	unsigned int pointer = *in;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;
	return (pImage->xHandle);
}


//-----------------------------------------------------------------------------
// Name: ImageYHandleBB
// Desc: Returns y handle of an image
//-----------------------------------------------------------------------------
int ImageYHandleBB INTPARAMS
{ 	
	unsigned int pointer = *in;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
    if(pImage->pSurface == NULL) return 0;
	return (pImage->yHandle);
}


//-----------------------------------------------------------------------------
// Name: LineBB()
// Desc: Draws a line at the specified location using the current pen.
//-----------------------------------------------------------------------------
int LineBB STDPARAMS
{
	int startX = *in; in = in+1;
	int startY = *in; in = in+1;
	int endX = *in; in = in+1;
	int endY = *in;
	
	//Get hDC of backbuffer
	HDC hDC = NULL;
	g_pCurrentSurface->Restore(); //Make sure the surface is restored	
	g_pCurrentSurface->GetDC(&hDC);//Get the DC of the surface

	if (g_hPen != NULL) SelectObject(hDC, g_hPen); 
	SetBkMode(hDC, TRANSPARENT);

	//Move current drawing location
	MoveToEx(
		hDC,// handle to DC
		startX, // x-coordinate of starting point
		startY, // y-coordinate of starting point
		NULL); //pointer to a POINT structure that receives 
			//the previous current position

	//Draw the line
	LineTo(
		hDC,// handle to DC
		endX, // x-coordinate of ending point
		endY); // y-coordinate of ending point

	g_pCurrentSurface->ReleaseDC(hDC);
	return (1);
}


//-----------------------------------------------------------------------------
// Name: Load3DImageBB()
// Desc: Loads a 3D-enabled sprite or image. Such images have the can use
//	real time rotations, scaling, and alpha blending. They do not
//	work in 8 bit (paletted) display modes, however. The loaded image
//	should also be square, and its width and height both a power of 2.
//	Example dimensions are 32x32, 64x64, 128x128, etc. Some video
//	cards may not be able to load images much larger than that.
//-----------------------------------------------------------------------------
int Load3DImageBB (char *in,char in_size,long *out,int out_sz )
{
	if (g_screenDepth == 8 || g_screenDepth == 24) return 0;
	char* szBitmap = in;//file name of bitmap
	HRESULT hr;

	//METHOD #1 = Not using Free Image (in which case, only bmps
	//are supported)
	if (g_FreeImage == 0)
	{

	//Try to load the bitmap from disk
	HBITMAP                 hbm;  //handle of the loaded bitmap
	BITMAP                  bm;   //bitmap class
	hbm = (HBITMAP) LoadImage( //type cast the handle
        NULL,  //hInstance of image
        szBitmap, //string indicating source of file
        IMAGE_BITMAP,//image type, as opposed to IMAGE_CURSOR or IMAGE_ICON
        0, //desired image width if resizing, 0 if using original width
        0, //desired image width if resizing, 0 if using original height
        LR_LOADFROMFILE | LR_CREATEDIBSECTION);

	//If that fails, exit
	if (hbm == NULL) return 0;

	//Save the bitmap in a Windows GUI-compatible device context
	HDC hdcImage = CreateCompatibleDC(NULL);//create device context for image
	SelectObject( //place the bitmap into the memory DC
	hdcImage,//device context of image created above
	hbm);//handle of the loaded bitmap

	//Set up the Direct Draw surface description
	DDSURFACEDESC2 ddsd;
	ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
	ddsd.dwSize          = sizeof(DDSURFACEDESC2);
	ddsd.dwFlags = DDSD_CAPS       | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT       | //dwHeight member is valid
                 DDSD_WIDTH        | //dwWidth member is valid
                 DDSD_PIXELFORMAT  |
				 DDSD_TEXTURESTAGE | //it's a D3D texture
                 DDSD_CKSRCBLT;      //color key enabled
	ddsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE;
    //           | DDSCAPS2_TEXTUREMANAGE; 
    
	GetObject(hbm, sizeof(bm), &bm); // Get the size of the bitmap
	DWORD dwWidth  = (DWORD)bm.bmWidth;
	DWORD dwHeight = (DWORD)bm.bmHeight;
	ddsd.dwWidth = dwWidth;  //record image width (gotten from GetObject)
	ddsd.dwHeight = dwHeight;  //record image height (gotten from GetObject)

	// Adjust width and height, if the driver requires it
	D3DDEVICEDESC7 ddDesc;
	if(FAILED(g_pD3DDevice->GetCaps(&ddDesc)))
	        return 0;
	if(ddDesc.dpcTriCaps.dwTextureCaps & D3DPTEXTURECAPS_POW2)
	{
        for( ddsd.dwWidth=1;  dwWidth>ddsd.dwWidth;   ddsd.dwWidth<<=1 );
        for( ddsd.dwHeight=1; dwHeight>ddsd.dwHeight; ddsd.dwHeight<<=1 );
	}
	if( ddDesc.dpcTriCaps.dwTextureCaps & D3DPTEXTURECAPS_SQUAREONLY )
	{
        if(ddsd.dwWidth > ddsd.dwHeight) ddsd.dwHeight = ddsd.dwWidth;
        else                             ddsd.dwWidth  = ddsd.dwHeight;
	}

	// Enumerate the texture formats, and find the closest device-supported
	// texture pixel format. Use the TextureSearchCallback function.
	g_pD3DDevice->EnumTextureFormats( TextureSearchCallback, &ddsd.ddpfPixelFormat );
	if( 0L == ddsd.ddpfPixelFormat.dwRGBBitCount )
        return 0;

	//Create the Direct Draw surface in specified memory area
	LPDIRECTDRAWSURFACE7 pSurface; //pointer to Direct Draw surface
	if (g_pDirectDraw->CreateSurface(
	&ddsd, //address of above DDSURFACEDESC2 structure that describes surface
	&pSurface, //address of the variable pointing to the surface
	NULL)  //advanced COM stuff
	!= DD_OK) return 0;

	//If this fails, exit
	if (pSurface == NULL) return 0;

	//Get device context of Direct Draw surface
	HDC hdc;  //handle of display version of image
	pSurface->Restore();
	if ((hr = pSurface->GetDC(&hdc)) == DD_OK)

	//Copy the bitmap to Direct Draw surface.
	{
	BitBlt(
		hdc,	// handle of VRAM destination DC
		0,		// x-coord of destination upper-left corner
		0,		// y-coord of destination upper-left corner
		ddsd.dwWidth,	// width of destination rectangle
		ddsd.dwHeight,	// height of destination rectangle
		hdcImage,	// handle of RAM source DC
		0, // x-coord of source upper-left corner
		0, // y-coord of source upper-left corner
		SRCCOPY );	// raster operation code
	}

	//Clean up by releasing stuff we don't need anymore
	if( FAILED( hr = pSurface->ReleaseDC(hdc))) return 0;
	DeleteDC(hdcImage);//delete the GUI device context (DC)
	DeleteObject(hbm);//delete the bitmap object.

	//Create a new cImage class instance to hold image data 
	cImage* pImage = CreateCImage (pSurface,
		ddsd.dwWidth, ddsd.dwHeight, //image dimensions
		0, 1, false, //memLocation, make3D, isAnimated
		0); //frameWidth, frameHeight, firstFrame, frameCount

	return((unsigned int) pImage);//return pointer pImage
	}

	//METHOD #2 = Using Free Image (supports png/jpg)
	else
	{

	//Load it as a Free Image file
	FREE_IMAGE_FORMAT fif = fpFreeImage_GetFIFFromFilename(szBitmap);
	FIBITMAP *dib = fpFreeImage_Load(fif,szBitmap);

	//Set up the Direct Draw surface description
	DDSURFACEDESC2 ddsd;
	ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
	ddsd.dwSize          = sizeof(DDSURFACEDESC2);
	ddsd.dwFlags = DDSD_CAPS       | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT       | //dwHeight member is valid
                 DDSD_WIDTH        | //dwWidth member is valid
                 DDSD_PIXELFORMAT  |
				 DDSD_TEXTURESTAGE | //it's a D3D texture
                 DDSD_CKSRCBLT;      //color key enabled
	ddsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE;
    
	DWORD dwWidth = fpFreeImage_GetWidth(dib);  //record image width (gotten from GetObject)
	DWORD dwHeight = fpFreeImage_GetHeight(dib);  //record image height (gotten from GetObject)
	ddsd.dwWidth = dwWidth;  //record image width (gotten from GetObject)
	ddsd.dwHeight = dwHeight;  //record image height (gotten from GetObject)

	// Adjust width and height, if the driver requires it
	D3DDEVICEDESC7 ddDesc;
	if(FAILED(g_pD3DDevice->GetCaps(&ddDesc)))
	        return 0;
	if(ddDesc.dpcTriCaps.dwTextureCaps & D3DPTEXTURECAPS_POW2)
	{
        for( ddsd.dwWidth=1;  dwWidth>ddsd.dwWidth;   ddsd.dwWidth<<=1 );
        for( ddsd.dwHeight=1; dwHeight>ddsd.dwHeight; ddsd.dwHeight<<=1 );
	}
	if( ddDesc.dpcTriCaps.dwTextureCaps & D3DPTEXTURECAPS_SQUAREONLY )
	{
        if(ddsd.dwWidth > ddsd.dwHeight) ddsd.dwHeight = ddsd.dwWidth;
        else                             ddsd.dwWidth  = ddsd.dwHeight;
	}

	// Enumerate the texture formats, and find the closest device-supported
	// texture pixel format. Use the TextureSearchCallback function.
	g_pD3DDevice->EnumTextureFormats( TextureSearchCallback, &ddsd.ddpfPixelFormat );
	if( 0L == ddsd.ddpfPixelFormat.dwRGBBitCount )
        return 0;

	//Create the Direct Draw surface in specified memory area
	LPDIRECTDRAWSURFACE7 pSurface; //pointer to Direct Draw surface
	if (g_pDirectDraw->CreateSurface(
	&ddsd, //address of above DDSURFACEDESC2 structure that describes surface
	&pSurface, //address of the variable pointing to the surface
	NULL)  //advanced COM stuff
	!= DD_OK) return 0;

	//If this fails, exit
	if (pSurface == NULL) return 0;

	// Make sure the Direct Draw surface is restored.
	pSurface->Restore();

	//Get device context of Direct Draw surface
	HDC hdc;  //handle of display version of image
	if ((hr = pSurface->GetDC(&hdc)) == DD_OK)

	//Copy the source image to Direct Draw surface.
	{
	SetDIBitsToDevice(
        hdc, // handle to DC
		0,		// x-coord of destination upper-left corner
		0,		// y-coord of destination upper-left corner
		ddsd.dwWidth,	// width of destination rectangle
		ddsd.dwHeight,	// height of destination rectangle
		0, // x-coord of source upper-left corner
		0, // y-coord of source upper-left corner
        0,// first scan line in array
        fpFreeImage_GetHeight(dib), // number of scan lines
        fpFreeImage_GetBits(dib), // array of DIB bits
        fpFreeImage_GetInfo(dib), // bitmap information
        DIB_RGB_COLORS); // RGB or palette indexes
	}

	//Clean up by releasing stuff we don't need anymore
	if( FAILED( hr = pSurface->ReleaseDC(hdc))) return NULL;
	fpFreeImage_Unload(dib);

	//Create a new cImage class instance to hold image data 
	cImage* pImage = CreateCImage (pSurface,
		ddsd.dwWidth, ddsd.dwHeight, //image dimensions
		0, 1, false, //memLocation, make3D, isAnimated
		0); //frameWidth, frameHeight, firstFrame, frameCount

	return((unsigned int) pImage);//return pointer pImage
	}
}


//-----------------------------------------------------------------------------
// Name: loadDLL 
//-----------------------------------------------------------------------------
int loadDLL INTPARAMS
{ 
	return 1;
}


//-----------------------------------------------------------------------------
// Name: LoadFreeImageBB()
// Desc: Loads the FreeImage.dll library and gets pointers to the
// needed functions. We are using explicit linking so our dll
// won't quit if the FreeImage.dll isn't found.
//-----------------------------------------------------------------------------
int LoadFreeImageBB INTPARAMS
{
	//Use explicit linking for FreeImage functions. That way this
	//dll won't quit if FreeImage isn't available
	if (g_hDLL == NULL) g_hDLL = LoadLibrary("FreeImage.dll");
	if (g_hDLL != NULL)
	{
		fpFreeImage_GetFIFFromFilename = (LPFNDLLFUNC1) 
			GetProcAddress(g_hDLL,
			"_FreeImage_GetFIFFromFilename@4");		
		fpFreeImage_Load = (LPFNDLLFUNC2) 
			GetProcAddress(g_hDLL,
			"_FreeImage_Load@12");
		fpFreeImage_GetWidth = (LPFNDLLFUNC3) 
			GetProcAddress(g_hDLL,
			"_FreeImage_GetWidth@4");
		fpFreeImage_GetHeight = (LPFNDLLFUNC3) 
			GetProcAddress(g_hDLL,
			"_FreeImage_GetHeight@4");
		fpFreeImage_GetBits = (LPFNDLLFUNC4) 
			GetProcAddress(g_hDLL,
			"_FreeImage_GetBits@4");
		fpFreeImage_GetInfo = (LPFNDLLFUNC5) 
			GetProcAddress(g_hDLL,
			"_FreeImage_GetInfo@4");
		fpFreeImage_Unload = (LPFNDLLFUNC6) 
			GetProcAddress(g_hDLL,
			"_FreeImage_Unload@4");
		g_FreeImage = 1;
		return 1;
	}
	return 0;
}


//-----------------------------------------------------------------------------
// Name: LoadImageBB()
// Desc: Create a Direct Draw Surface from a bitmap resource.
//-----------------------------------------------------------------------------
int LoadImageBB INTPARAMS
{ 
	//Get incoming info.
	int loadTo = *in; in++;//flag that says where to load image to (VRAM/RAM)
	int frameWidth = *in; in++;//if animated, width of frame
	int frameHeight = *in; in++;//if animated, height of frame
	int firstFrame = *in; in++;//if animated, first frame
	int frameCount = *in; in++;//if animated, count of frames
	char* szBitmap = (char*) in; //file name of bitmap
	HRESULT                 hr; 

	//METHOD #1 = Not using Free Image (in which case, only bmps
	//are supported)
	if (g_FreeImage == 0)
	{

	//Load the bitmap from disk
	HBITMAP                 hbm;  //handle of the loaded bitmap
	BITMAP                  bm;   //bitmap class
	hbm = (HBITMAP) LoadImage( //type cast the handle
        NULL,  //hInstance of image
        szBitmap, //string indicating source of file
        IMAGE_BITMAP,//image type, as opposed to IMAGE_CURSOR or IMAGE_ICON
        0, //desired image width if resizing, 0 if using original width
        0, //desired image width if resizing, 0 if using original height
        LR_LOADFROMFILE | LR_CREATEDIBSECTION);

	//If that fails, exit
	if (hbm == NULL) return NULL;

	//Save the bitmap in a Windows GUI-compatible device context
	//Note that doing this may slightly change the exact RGB colors used in the
	//original bitmap if the bytes per pixel in the incoming bitmap are
	//higher than the color depth being used in the game. For example,
	//if the game is a 256 color, 8 bit game, and the loaded image is 24 
	//color, "selecting" the bitmap into the compatible DC will involve
	//mapping the 24 color image as well as possible to the 256 color
	//palette that is being used. Conversions the other way (8 bit to 24 bit)
	//should involve no color loss, however.
	HDC hdcImage = CreateCompatibleDC(NULL);//create device context for image
	SelectObject( //place the bitmap into the memory DC
	hdcImage,//device context of image created above
	hbm);//handle of the loaded bitmap

	//Set up the Direct Draw surface description
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT | //dwHeight member is valid
                 DDSD_WIDTH;   //dwWidth member is valid

	//Specify type of surface (plain offscreen) and location (VRAM/RAM)
	if (loadTo == 0) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN; 
	if (loadTo == 1) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN 
		| DDSCAPS_SYSTEMMEMORY; //load to RAM if loadTo == 1

	GetObject(hbm, sizeof(bm), &bm); // Get the size of the bitmap
	ddsd.dwWidth = bm.bmWidth;  //record image width (gotten from GetObject)
	ddsd.dwHeight = bm.bmHeight;  //record image height (gotten from GetObject)

	//Create the Direct Draw surface in specified memory area
	LPDIRECTDRAWSURFACE7 pSurface; //pointer to Direct Draw surface
	if (g_pDirectDraw->CreateSurface(
	&ddsd, //address of above DDSURFACEDESC2 structure that describes surface
	&pSurface, //address of the variable pointing to the surface
	NULL)  //advanced COM stuff
	!= DD_OK) return ReleaseBitmap(hdcImage, hbm);

	//If this fails, exit
	if (pSurface == NULL) return ReleaseBitmap(hdcImage, hbm);

	// Make sure the Direct Draw surface is restored.
	pSurface->Restore();

	//Get device context of Direct Draw surface
	HDC hdc;  //handle of display version of image
	if ((hr = pSurface->GetDC(&hdc)) == DD_OK)

	//Copy the bitmap to Direct Draw surface.
	{
	BitBlt(
		hdc,	// handle of VRAM destination DC
		0,		// x-coord of destination upper-left corner
		0,		// y-coord of destination upper-left corner
		ddsd.dwWidth,	// width of destination rectangle
		ddsd.dwHeight,	// height of destination rectangle
		hdcImage,	// handle of RAM source DC
		0, // x-coord of source upper-left corner
		0, // y-coord of source upper-left corner
		SRCCOPY );	// raster operation code
	}

	//Clean up by releasing stuff we don't need anymore
	if( FAILED( hr = pSurface->ReleaseDC(hdc))) 
		return ReleaseBitmap(hdcImage, hbm, pSurface);
	DeleteDC(hdcImage);//delete the GUI device context (DC)
	DeleteObject(hbm);//delete the bitmap object.

	//Create a new cImage class instance to hold image data 
	cImage* pImage;
	if (frameCount == 1)
	{
		pImage = CreateCImage (pSurface,
			ddsd.dwWidth, ddsd.dwHeight, //image dimensions
			loadTo, 0, false, //memLocation, make3D, isAnimated
			frameWidth, frameHeight, firstFrame, frameCount);
	}
	else
	{
		pImage = CreateCImage (pSurface,
			ddsd.dwWidth, ddsd.dwHeight, //image dimensions
			loadTo, 0, true, //memLocation, make3D, isAnimated
			frameWidth, frameHeight, firstFrame, frameCount);
	}

	return((unsigned int) pImage);//return pointer pImage	
	}

	//METHOD #2 = If it is another file type (jpg, png)
	else
	{

	//Load it as a Free Image file
	FREE_IMAGE_FORMAT fif = fpFreeImage_GetFIFFromFilename(szBitmap);
	FIBITMAP *dib = fpFreeImage_Load(fif,szBitmap);

	//Set up the Direct Draw surface description
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT | //dwHeight member is valid
                 DDSD_WIDTH;   //dwWidth member is valid

	//Specify type of surface (plain offscreen) and location (VRAM/RAM)
	if (loadTo == 0) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN; 
	if (loadTo == 1) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN 
		| DDSCAPS_SYSTEMMEMORY; //load to RAM if loadTo == 1

	ddsd.dwWidth = fpFreeImage_GetWidth(dib);  //record image width (gotten from GetObject)
	ddsd.dwHeight = fpFreeImage_GetHeight(dib);  //record image height (gotten from GetObject)

	//Create the Direct Draw surface in specified memory area
	LPDIRECTDRAWSURFACE7 pSurface; //pointer to Direct Draw surface
	if (g_pDirectDraw->CreateSurface(
	&ddsd, //address of above DDSURFACEDESC2 structure that describes surface
	&pSurface, //address of the variable pointing to the surface
	NULL)  //advanced COM stuff
	!= DD_OK) return NULL;

	//If this fails, exit
	if (pSurface == NULL) return NULL;

	// Make sure the Direct Draw surface is restored.
	pSurface->Restore();

	//Get device context of Direct Draw surface
	HDC hdc;  //handle of display version of image
	if ((hr = pSurface->GetDC(&hdc)) == DD_OK)

	//Copy the source image to Direct Draw surface.
	{
	SetDIBitsToDevice(
        hdc, // handle to DC
		0,		// x-coord of destination upper-left corner
		0,		// y-coord of destination upper-left corner
		ddsd.dwWidth,	// width of destination rectangle
		ddsd.dwHeight,	// height of destination rectangle
		0, // x-coord of source upper-left corner
		0, // y-coord of source upper-left corner
        0,// first scan line in array
        fpFreeImage_GetHeight(dib), // number of scan lines
        fpFreeImage_GetBits(dib), // array of DIB bits
        fpFreeImage_GetInfo(dib), // bitmap information
        DIB_RGB_COLORS); // RGB or palette indexes
	}

	//Clean up by releasing stuff we don't need anymore
	if( FAILED( hr = pSurface->ReleaseDC(hdc))) return NULL;
	fpFreeImage_Unload(dib);

	//Create a new cImage class instance to hold image data 
	cImage* pImage;
	if (frameCount == 1)
	{
		pImage = CreateCImage (pSurface,
			ddsd.dwWidth, ddsd.dwHeight, //image dimensions
			loadTo, 0, false, //memLocation, make3D, isAnimated
			frameWidth, frameHeight, firstFrame, frameCount);
	}
	else
	{
		pImage = CreateCImage (pSurface,
			ddsd.dwWidth, ddsd.dwHeight, //image dimensions
			loadTo, 0, true, //memLocation, make3D, isAnimated
			frameWidth, frameHeight, firstFrame, frameCount);
	}

	return((unsigned int) pImage);//return pointer pImage
	}
}



//-----------------------------------------------------------------------------
// Name: LoadPalette
// Desc: Loads a palette from a particular bitmap. This function is called
// from the Graphics function.
//-----------------------------------------------------------------------------
HRESULT LoadPalette(
	LPDIRECTDRAWPALETTE* ppPalette,//global variable pointing to palette
	const TCHAR* strBMP )//string representing file location of bitmap
{
	HANDLE            hFile = NULL;//handle of the bitmap file being opened
	DWORD             iColor; //specific color entry in palette
	DWORD             dwColors;//total number of colors used in bitmap
	BITMAPFILEHEADER  bf;//structure that holds bitmap file info
	BITMAPINFOHEADER  bi;//structure that holds bitmap header info
	DWORD             dwBytesRead;//used by ReadFile (see below)

	if( g_pDirectDraw == NULL || strBMP == NULL || ppPalette == NULL )
        return 0;

	*ppPalette = NULL;

	// Read the bitmap's file, header, and palette information.
	hFile = CreateFile( 
	strBMP, //string representing file location of bitmap
	GENERIC_READ, //declare desired file access rights as generic read-only
	0, //Prevent access to file until handle is closed (see below)
	NULL, //security attributes of file
	OPEN_EXISTING, //action to take on file
	0, //file attributes flags (encripted, read-only, hidden, etc.)
	NULL);//unused file template parameter
	if( NULL == hFile )
        return E_FAIL;

	// Read the BITMAPFILEHEADER, which contains info about the bitmap's
	// type (bitmap) and size.
	ReadFile( 
	hFile, //handle of file to be read
	&bf,   //address of structure that will receive the read info
	sizeof(bf), //number of bytes to read from the file
	&dwBytesRead, //pointer to the variable that receives the number of bytes read.
	NULL );//overlapped bytes stuff (unused)
	if( dwBytesRead != sizeof(bf) )
	{
        CloseHandle( hFile );
        return E_FAIL;
	}


	// Read the BITMAPINFOHEADER, a data structure that contains info
	// about the bitmap's size, width, height, color depth, compression, etc.
	ReadFile( hFile, &bi, sizeof(bi), &dwBytesRead, NULL );
	if( dwBytesRead != sizeof(bi) )
	{
        CloseHandle( hFile );
        return E_FAIL;
	}

	// Read the PALETTEENTRY, read pallete info from the bitmap and 
	// save it in the g_PaletteEntry PALETTEENTRY structure.
	ReadFile( hFile, g_PaletteEntry, sizeof(g_PaletteEntry), &dwBytesRead, NULL );
	if( dwBytesRead != sizeof(g_PaletteEntry) )
	{
        CloseHandle( hFile );
        return E_FAIL;
	}

	CloseHandle( hFile );

	//  Colors stored in a DIB (bitmap) palette are in BGR order.
	//  Colors used in a Direct Draw PALETTEENTRY structure are
	//  in RGB order, so flip them around. The PALETTEENTRY 
	//  structure also holds alpha information, but it's not used here.

	// Figure out how many colors there are by reading it from the 
	// bitmap header.
	if( bi.biSize != sizeof(BITMAPINFOHEADER) )
        dwColors = 0;
	else if (bi.biBitCount > 8) //if bit count of bitmap is > 8
        dwColors = 0;           //set palette colors used to 0
	else if (bi.biClrUsed == 0)
        dwColors = 1 << bi.biBitCount;
	else
        dwColors = bi.biClrUsed; //header info indicating # colors
                 //from header used in bitmap

	//For each color in the g_PaletteEntry PALETTEENTRY structure, swap the red 
	//and blue values so they are in the correct order.
	for( iColor = 0; iColor < dwColors; iColor++ )
	{
        BYTE r = g_PaletteEntry[iColor].peRed; //read red value
        g_PaletteEntry[iColor].peRed  = g_PaletteEntry[iColor].peBlue; //swap blue into red
        g_PaletteEntry[iColor].peBlue = r; //save blue into red position
	}

	//Create the pallete from the g_PaletteEntry PALETTEENTRY structure.	
	return g_pDirectDraw->CreatePalette(
	DDPCAPS_8BIT, //flag indicated its an 8 bit/256 color palette
	g_PaletteEntry, //address of array of PALETTEENTRY structures
	ppPalette, //pointer to palette. This is used by SetPalette()
	NULL ); //advanced COM stuff

}


//--------------------------------------------------------------------------
// Name: MakeAnimatedBB
// Desc: Transforms an ordinary 2D image into an animated image
//-----------------------------------------------------------------------------
int MakeAnimatedBB INTPARAMS
{
	//Get and translate the image pointer
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return -1;
	if(pImage->pSurface == NULL) return -2;
	if(pImage->imageIs3D == true) return -3;
	int frameWidth = *in; in++;//if animated, width of frame
	int frameHeight = *in; in++;//if animated, height of frame
	int firstFrame = *in; in++;//if animated, first frame
	int frameCount = *in; in++;//if animated, count of frames

	pImage->isAnimated = true; //if animated
	pImage->frameWidth = frameWidth;//if animated, width of frame
	pImage->frameHeight = frameHeight;//if animated, height of frame
	pImage->firstFrame = firstFrame;//if animated, first frame
	pImage->frameCount = frameCount;//if animated, count of frames
	pImage->framesWide = pImage->imageWidth/frameWidth;
	return 1;
}


//--------------------------------------------------------------------------
// Name: MaskImageBB
// Desc: Masks an image  
//-----------------------------------------------------------------------------
int MaskImageBB STDPARAMS
{	
	//Get and translate the image pointer
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return -1;
	if(pImage->pSurface == NULL) return -2;
	int r = *in; in++;
	int g = *in; in++;
	int b = *in;

	DDCOLORKEY ddck;
	COLORREF rgb = RGB(r,g,b);
	ddck.dwColorSpaceLowValue = ColorMatch(pImage->pSurface, rgb,
		pImage->imageIs3D);
	ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
	pImage->convertedMaskColor = ddck.dwColorSpaceLowValue;
	pImage->isMasked = true;
	return pImage->pSurface->SetColorKey(DDCKEY_SRCBLT, &ddck);
}


//-----------------------------------------------------------------------------
// Name: Message BoxBB 
// Desc: Generates a Windows message box. 
//-----------------------------------------------------------------------------
int MessageBoxBB CHARPARAMS
{
	char* pWindowTitle = in;//parent application window title
	in = in+strlen(pWindowTitle)+1;
	char* title = in;//pointer to start of 1st null-terminated string
	in = in+strlen(title)+1;
	char* boxText = in;//pointer to start of 2nd string
	MessageBox(FindWindow(NULL,pWindowTitle),boxText,title,MB_OK|MB_ICONERROR);   
	return(strlen(title));
}



//-----------------------------------------------------------------------------
// Name: MidHandleBB
// Desc: Sets a handle for an image.
//-----------------------------------------------------------------------------
int MidHandleBB INTPARAMS
{ 	
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return -1;
	if(pImage->pSurface == NULL) return -2;
	pImage->xHandle = pImage->frameWidth/2;
	pImage->yHandle = pImage->frameHeight/2;
	return 1;
}


//-----------------------------------------------------------------------------
// Name: MoveMouseBB()
// Desc: Moves the mouse to the selected spot on the screen. 
//-----------------------------------------------------------------------------
void MoveMouseBB INTPARAMS
{
	//Get incoming info
	int x = *in; in++;
	int y = *in;
	
	g_CurrentMouseX = x;
	if (g_CurrentMouseX < 0) g_CurrentMouseX = 0;
	if (g_CurrentMouseX >= g_screenWidth) g_CurrentMouseX = g_screenWidth-1;

	g_CurrentMouseY = y;
	if (g_CurrentMouseY < 0) g_CurrentMouseY = 0;
	if (g_CurrentMouseY >= g_screenHeight) g_CurrentMouseY = g_screenHeight-1;
}


//-----------------------------------------------------------------------------
// Name: MouseHitBB()
// Desc: Checks to see how many times the mouse has been hit since the
//	last time this command was called. This command uses buffered Direct
//	Input data via GetDeviceData.
//-----------------------------------------------------------------------------
int MouseHitBB INTPARAMS
{
	DIDEVICEOBJECTDATA inputBuffer[16]; //array storing buffer items
	DWORD numberItems = 10; // number of items to be retrieved
	int leftMouseHits = 0;
	int rightMouseHits = 0;

	HRESULT hr = g_pMouse->GetDeviceData(
		sizeof(DIDEVICEOBJECTDATA),          
		inputBuffer,  
		&numberItems,            
		0);//use DIGDD_PEEK to leave buffered items in buffer

	//Unable to read data or no data available
	if (FAILED(hr))
	{
		*out = 0; out++;
		*out = 0;
		return -1;
	}		
	if (numberItems == 0) 
	{
		*out = 0; out++;
		*out = 0;
		return 0;
	}

	//Cycle through elements in buffer
	for (DWORD item=0; item < numberItems; item++)
	{

	//Left button pressed or released 
	if ((inputBuffer[item].dwOfs == DIMOFS_BUTTON0) && 
		(inputBuffer[item].dwData & 0x80))
		leftMouseHits = leftMouseHits+1;

	//Right button pressed or released
	if ((inputBuffer[item].dwOfs == DIMOFS_BUTTON1) && 
		(inputBuffer[item].dwData & 0x80)) 
		rightMouseHits = rightMouseHits+1;

	}

	*out = leftMouseHits; out++;
	*out = rightMouseHits;
	return numberItems;
}


//-----------------------------------------------------------------------------
// Name: OvalBB()
// Desc: Draws an oval at the specified location  
//-----------------------------------------------------------------------------
int OvalBB STDPARAMS
{
	int x = *in; in = in+1;
	int y = *in; in = in+1;
	int width = *in; in = in+1;
	int height = *in; in = in+1;
	int solid = *in; //0 = transparent; 1 = solid
	
	//Get hDC of current buffer
	HDC hDC = NULL;
	g_pCurrentSurface->Restore(); //Make sure the surface is restored	
	g_pCurrentSurface->GetDC(&hDC);//Get the DC of the surface

	//Set the border pen and fill brush
	if (g_hPen != NULL) SelectObject(hDC, g_hPen);	
	if (solid==0) SelectObject(hDC, GetStockObject(NULL_BRUSH));
	if (solid==1) SelectObject(hDC, g_hBrush);
	if (solid==1) SetBkMode(hDC, TRANSPARENT);

	Ellipse(
		hDC,// handle to DC
		x, // int x-coord of upper-left corner of oval
		y, // int y-coord of upper-left corner of oval
		x+width, // int x-coord of lower-right corner of oval
		y+height); // int y-coord of lower-right corner of oval

	g_pCurrentSurface->ReleaseDC(hDC);
	return (1);
}


//-----------------------------------------------------------------------------
// Name: PlotBB()
// Desc: Draws a pixel at the specified location.  
//-----------------------------------------------------------------------------
int PlotBB STDPARAMS
{
	int x = *in; in = in+1;
	int y = *in; in = in+1;
	int r = *in; in = in+1;
	int g = *in; in = in+1;
	int b = *in;
	
	//Get hDC of current buffer
	HDC hDC = NULL;
	if (g_pCurrentBuffer == 3) {
		if (g_pCurrentImage->imageIs3D == true)
			return -1;
	}
	g_pCurrentSurface->Restore(); //Make sure the surface is restored	
	g_pCurrentSurface->GetDC(&hDC);//Get the DC of the surface

	SetPixel(
		hDC,       // handle to DC
		x,             // x-coordinate of pixel
		y,             // y-coordinate of pixel
		RGB(r,g,b));   // pixel color

	g_pCurrentSurface->ReleaseDC(hDC);
	return (1);
}


//-----------------------------------------------------------------------------
// Name: ReadPaletteBB
// Desc: Reads the RGB values of a given palette entry in a 256 color palette
//-----------------------------------------------------------------------------
void ReadPaletteBB BYTEPARAMS
{
	byte iColor = *in;
	*out = g_PaletteEntry[iColor].peRed; out++;
	*out = g_PaletteEntry[iColor].peGreen; out++;
	*out = g_PaletteEntry[iColor].peBlue;
}



//-----------------------------------------------------------------------------
// Name: ReadPixel
// Desc: Internal version of ReadPixelBB used by AutoMaskImagePixelBB.
//		Mode = 0 returns rgb data; Mode = 1 returns raw pixel data.
//-----------------------------------------------------------------------------
COLORREF ReadPixel (cImage* pImage, int x, int y, int mode=0)
{
	COLORREF color = 0;
	COLORREF rgb = 0;

	if (x >= pImage->imageWidth) return 0;
	if (y >= pImage->imageHeight) return 0;

	//Set up the Direct Draw surface description
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);

	//Lock the surface
	HRESULT hr = pImage->pSurface->Lock(
		NULL,//lock entire surface
		&ddsd,  
		DDLOCK_WAIT | DDLOCK_NOSYSLOCK,                    
		NULL);
	if (hr != DD_OK) return 0;//couldn't lock surface so exit
	int pixelFormat = ddsd.ddpfPixelFormat.dwRGBBitCount;
	int pitch = ddsd.lPitch; //get the pitch 

	//Read pixel info
	if (pixelFormat == 8)
	{
		byte* pSurface = (byte*) ddsd.lpSurface; //Grab surface pointer
		color = *(pSurface+x+y*pitch);
	}

	if (pixelFormat == 16)
	{
		short* pSurface = (short*) ddsd.lpSurface; //Grab surface pointer
		pitch = pitch/2; //adjust pitch to short value
		color = *(pSurface+x+y*pitch);
	}	

	if (pixelFormat == 24)
	{
		byte* pSurface = (byte*) ddsd.lpSurface; //Grab surface pointer
		color = *((int*) (pSurface+3*x+y*pitch)) & 0x00FFFFFF;
	}

	if (pixelFormat == 32)
	{
		int* pSurface = (int*) ddsd.lpSurface; //Grab surface pointer
		pitch = pitch/4; //adjust pitch to int value
		color = *(pSurface+x+y*pitch);
	}

	//Unlock the surface
	pImage->pSurface->Unlock(NULL);

	//If returning pixel data
	if (mode == 0 && g_screenDepth == 16) //if 16 bit rgb

		//Return rgb equivalent of naked 16 bit data
		if (g_screenFormat16Bit == 555)	
		{
			int r = 8*((color >> 10) % 32); //pos 10-14
			int g = 8*((color >> 5) % 32);//pos 5-9
			int b = 8*(color % 32);//pos 0-4
			return r << 16 | g << 8 | b;		
		}
		else //if 565
		{
			int r = 8*((color >> 11) % 32); //pos 11-15
			int g = 4*((color >> 5) % 64);//pos 5-10
			int b = 8*(color % 32);//pos 0-4
			return r << 16 | g << 8 | b;
		}

	else //otherwise return raw pixel data
		return color;		
}



//-----------------------------------------------------------------------------
// Name: ReadPixelBB
// Desc: Reads a pixel at a given location in the current drawing buffer
//	and returns the raw pixel info at that location. This is subsequently
//	translated into an RGB value by the calling Blitz function, depending
//	on the current color depth of the screen. This command is too slow for
//  3D enabled images.
//-----------------------------------------------------------------------------
int ReadPixelBB ( int *in,int in_size, byte *out,byte out_sz)
{
	//Read incoming coordinates
	int x = *in; in++; //x position
	int y = *in; //y position
	
	//Do some error checking on the coordinates vs. current
	//drawing buffer.
	if (g_pCurrentBuffer == 1 || g_pCurrentBuffer == 2)
	{
		if (x >= g_screenWidth) return -1;		
		if (y >= g_screenHeight) return -2;
	}
	else if (g_pCurrentBuffer == 3)
	{
		if (g_pCurrentImage->imageIs3D == true) return -3;
		if (x >= g_pCurrentImage->imageWidth) return -4;
		if (y >= g_pCurrentImage->imageHeight) return -5;
	}

	//Set up the Direct Draw surface description
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);

	//Lock the surface
	HRESULT hr = g_pCurrentSurface->Lock(
		NULL,//lock entire surface
		&ddsd,  
		DDLOCK_WAIT | DDLOCK_NOSYSLOCK,                    
		NULL);
	if (hr != DD_OK) return -6;//couldn't lock surface so exit
	byte* pSurface = (byte*) ddsd.lpSurface; //grab surface pointer
	int bytesPerPixel = ddsd.ddpfPixelFormat.dwRGBBitCount/8;
	int pitch = ddsd.lPitch; //get the pitch 

	//Read pixel info
	for (byte i=0;i < bytesPerPixel;i++)
	{
	*out = *(pSurface+x*bytesPerPixel+y*pitch+i);
	out++;
	}

	//Unlock the surface
	g_pCurrentSurface->Unlock(NULL);
	return ddsd.ddpfPixelFormat.dwRGBBitCount;
}


//--------------------------------------------------------------------------
// Name: ReadPixelFastBB
// Desc: Copies an image or portion of an image to a Blitz bank 
//	for fast reading
//-----------------------------------------------------------------------------
int ReadPixelFastBB (int *in,int in_size, byte *out, byte out_sz)
{

	//Get and translate the image pointer
	unsigned int pointer = *in; in++;
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	int x = *in; in++; //if copying a portion of image, x origin
	int y = *in; in++; //if copying a portion of image, y origin
	int width = *in; in++; //if copying a portion of image
	int height = *in; //if copying a portion of image

	LPDIRECTDRAWSURFACE7 thisImage=NULL;
	if (pointer == 1)
	{
		if (x == -1) return -3;//if locking frontbuffer, must specify area
		thisImage = g_pFrontBuffer;
	}
	else if (pointer == 2)
	{
		if (x == -1) return -3;//if locking backbuffer, must specify area
		thisImage = g_pBackBuffer;
	}
	else
	{
	if (pImage->imageIs3D == true) return 0;//too slow for 3D images
	if(pImage == NULL) return -1;
	if(pImage->pSurface == NULL) return -2;
	thisImage = pImage->pSurface;
	}

	//Lock surface of image
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);
	HRESULT hr = thisImage->Lock(
		NULL,//lock entire surface
		&ddsd,  
		DDLOCK_WAIT | DDLOCK_NOSYSLOCK,                    
		NULL);
	if (hr != DD_OK) //couldn't lock surface so exit
		return -4;
	int pitch = (int) ddsd.lPitch; //get the pitch 
	byte* pSurface = (byte*) ddsd.lpSurface; //Grab surface pointer
	int bytesPerPixel = ddsd.ddpfPixelFormat.dwRGBBitCount/8;

	//Either copy the whole image 
	if (x == -1)
		memcpy(out,pSurface,pImage->imageHeight*pitch);

	//Or copy the selected portion of the image
	else
	{
		for (int b=y;b<y+height;b++)
		{
			memcpy(out,pSurface+x*bytesPerPixel+b*pitch,width*bytesPerPixel);
			out = out+width*bytesPerPixel;
		}
	}

	thisImage->Unlock(NULL);
	if (x == -1) 
		return pitch;
	else
		return width*bytesPerPixel;
}


//-----------------------------------------------------------------------------
// Name: RectBB()
// Desc: Draws a rectangle at the specified location  
//-----------------------------------------------------------------------------
int RectBB STDPARAMS
{
	int x = *in; in = in+1;
	int y = *in; in = in+1;
	int width = *in; in = in+1;
	int height = *in; in = in+1;
	int solid = *in; //0 = transparent; 1 = solid

	//Get hDC of current buffer
	HDC hDC = NULL;
	g_pCurrentSurface->Restore(); //Make sure the surface is restored	
	g_pCurrentSurface->GetDC(&hDC);//Get the DC of the surface
 
	//Set the border pen and fill brush
	if (g_hPen != NULL) SelectObject(hDC, g_hPen);	
	if (solid==0) SelectObject(hDC, GetStockObject(NULL_BRUSH));
	if (solid==1) SetBkMode(hDC, TRANSPARENT); //Make it transparent
	if (solid==1) SelectObject(hDC, g_hBrush);

	Rectangle(
		hDC,// handle to DC
		x, // int x-coord of upper-left corner of rectangle
		y, // int y-coord of upper-left corner of rectangle
		x+width, // int x-coord of lower-right corner of rectangle
		y+height); // int y-coord of lower-right corner of rectangle

	g_pCurrentSurface->ReleaseDC(hDC);
	return (1);
}


//-----------------------------------------------------------------------------
// Name: ReleaseBitmap
// Desc: Releases a bitmap
//-----------------------------------------------------------------------------
int ReleaseBitmap(HDC hdcImage, HBITMAP hbm, 
				  LPDIRECTDRAWSURFACE7 pSurface)
{
	if (pSurface != NULL) pSurface->Release();
	DeleteDC(hdcImage);//delete the GUI device context (DC)
	DeleteObject(hbm);//delete the bitmap object.
	return 0;
}


//-----------------------------------------------------------------------------
// Name: ReleaseObjectsBB
// Desc: Releases Direct Draw objects.
//-----------------------------------------------------------------------------
int ReleaseObjectsBB(void)
{
	int imageCount = 0;//number of images freed

	//Delete GDI objects
	if (g_hBrush != NULL) DeleteObject(g_hBrush);
	if (g_hFont != NULL) DeleteObject(g_hFont);
	if (g_hPen != NULL) DeleteObject(g_hPen);

	//Release Direct3D objects (release before Direct Draw objects)
	if (g_pD3D != NULL)
	{
		//Release Direct3D device
		if (g_pD3DDevice != NULL)
		{
		g_pD3DDevice->Release();//this command causes an error
		g_pD3DDevice = NULL;
		}

		g_pD3D->Release();
		g_pD3D = NULL;
	}

	//Release Direct Draw objects
	if (g_pDirectDraw != NULL)
	{

		//Release all image objects and release their video memory
		imageCount = FreeAllImages();

		//Release palette, if any (8 bit mode)
		if (g_pPalette != NULL)
		{
		g_pPalette->Release();
		g_pPalette = NULL;
		}

		//Release backbuffer
		if (g_pBackBuffer != NULL)
		{
		g_pBackBuffer->Release();
		g_pBackBuffer = NULL;
		}

		//Release primary surface
		if (g_pFrontBuffer!= NULL)
		{
		g_pFrontBuffer->Release();
		g_pFrontBuffer= NULL;
		}

		//Release Direct Draw object
		g_pDirectDraw->Release();
		g_pDirectDraw = NULL;
	}

	//Release all Direct Input objects
	if (g_pDirectInput != NULL)
	{

		//Release Direct Input mouse
		if (g_pMouse != NULL)
		{
		g_pMouse->Unacquire();
		g_pMouse->Release();
		g_pMouse = NULL;
		}

		//Release Direct Imput object
		g_pDirectInput->Release();
		g_pDirectInput = NULL;
	}

	//Free the Free Image library if it was used
	if (g_hDLL != NULL) FreeLibrary (g_hDLL);	

	return imageCount;
}


//-----------------------------------------------------------------------------
// Name: ResizeImageBB
// Desc: Resizes an image to a specified image size in pixels.
//-----------------------------------------------------------------------------
int ResizeImageBB INTPARAMS
{
	unsigned int pointer = (unsigned int) *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return -1;
	if(pImage->pSurface == NULL) return -1;
	int width = *in; in++;
	int height = *in;

	//Error check: 
	if (pointer == 1 || pointer == 2) return -2; //can't resize front/back buffer
	if (pImage->imageIs3D == true) return -3; //can't resize 3D images
	if (pImage->isAnimated == true) return -4; //can't rotate animated images

	//Create a temporary image to copy scaled image to
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT | //dwHeight member is valid
                 DDSD_WIDTH;   //dwWidth member is valid
	if (pImage->memLocation == 0) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN; 
	if (pImage->memLocation == 1) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN 
		| DDSCAPS_SYSTEMMEMORY; //load to RAM if loadTo == 1
	ddsd.dwWidth = width;
	ddsd.dwHeight = height;
	int tempImageWidth = ddsd.dwWidth; //record dimensions for later
	int tempImageHeight = ddsd.dwHeight;

	LPDIRECTDRAWSURFACE7 pTempImage; //pointer to Direct Draw surface
	if (g_pDirectDraw->CreateSurface(
	&ddsd, //address of above DDSURFACEDESC2 structure that describes surface
	&pTempImage, //address of the variable pointing to the new image
	NULL)  //advanced COM stuff
	!= DD_OK) return -3;

	//Compute source rectangle
	RECT rectSource;
	rectSource.left=0;
	rectSource.right= pImage->imageWidth;
	rectSource.top=0;
	rectSource.bottom= pImage->imageHeight;

	//Compute destination rectangle
	RECT rectDest;
	rectDest.left=0;
	rectDest.right= tempImageWidth;
	rectDest.top=0;
	rectDest.bottom= tempImageHeight;

	//Blit to the destination image
	HRESULT hr = pTempImage->Blt(
	&rectDest, //Destination RECT
	pImage->pSurface,  //lpDDSrcSurface
	&rectSource, //Source RECT or NULL for entire surface
	DDBLT_WAIT, //flags
	NULL); //special effects

	//Now delete the original image and put the new image
	//in its place
	pImage->pSurface->Release();
	pImage->pSurface = pTempImage;
	pImage->imageWidth = tempImageWidth;
	pImage->imageHeight = tempImageHeight;
	pImage->frameWidth = tempImageWidth;
	pImage->frameHeight = tempImageHeight;
	if (g_AutoMidHandle == true)
	{
	pImage->xHandle = pImage->imageWidth/2;
	pImage->yHandle = pImage->imageHeight/2;
	}

	//If appropriate, mask the new image the same as the original
	if (pImage->isMasked == true)
	{
	DDCOLORKEY ddck;
	ddck.dwColorSpaceLowValue = pImage->convertedMaskColor;
	ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
	pImage->pSurface->SetColorKey(DDCKEY_SRCBLT, &ddck);
	}

	return 1;
}


//-----------------------------------------------------------------------------
// Name: RotateImageBB
// Desc: Rotates a pre-existing image in a clockwise direction by
// 90, 180, or 270 degrees.
//-----------------------------------------------------------------------------
int RotateImageBB INTPARAMS
{
	//Get incoming info
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return 0;
	if(pImage->pSurface == NULL) return 0;	
	int angle = *in; //must be 90, 180, or 270
	angle = (angle/90) % 4;//convert angle to 0,1,2,3
	char loadTo = pImage->memLocation;

	//Error check: 
	if (pImage->imageIs3D == true) return 0; //can't rotate 3D images
	if (pImage->isAnimated == true) return 0; //can't rotate animated images

	//Create a temporary image to copy rotated image to
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | //ddsCaps structure is valid (see below
                 DDSD_HEIGHT | //dwHeight member is valid
                 DDSD_WIDTH;   //dwWidth member is valid
	if (loadTo == 0) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN; 
	if (loadTo == 1) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN 
		| DDSCAPS_SYSTEMMEMORY; //load to RAM if loadTo == 1
	if (angle == 0 || angle == 2){
		ddsd.dwWidth = pImage->imageWidth;
		ddsd.dwHeight = pImage->imageHeight;
	}
	else {
		ddsd.dwWidth = pImage->imageHeight;
		ddsd.dwHeight = pImage->imageWidth;
	}
	int tempImageWidth = ddsd.dwWidth; //record dimensions for later
	int tempImageHeight = ddsd.dwHeight;
	LPDIRECTDRAWSURFACE7 pTempImage; //pointer to Direct Draw surface
	if (g_pDirectDraw->CreateSurface(
	&ddsd, //address of above DDSURFACEDESC2 structure that describes surface
	&pTempImage, //address of the variable pointing to the new image
	NULL)  //advanced COM stuff
	!= DD_OK) return -1;

	//Lock surface of temporary image
	HRESULT hr = pTempImage->Lock(
		NULL,//lock entire surface
		&ddsd,  
		DDLOCK_WAIT | DDLOCK_NOSYSLOCK,                    
		NULL);
	if (hr != DD_OK) //couldn't lock image so delete it and exit
	{
		pTempImage->Release();
		pTempImage = NULL;
		return -2;
	}
	int tempPitch = (int) ddsd.lPitch; //get the image pitch 
	byte* pTempSurface = (byte*) ddsd.lpSurface; //grab surface pointer

	//Lock surface of source image
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);
	hr = pImage->pSurface->Lock(
		NULL,//lock entire surface
		&ddsd,  
		DDLOCK_WAIT | DDLOCK_NOSYSLOCK,                    
		NULL);
	if (hr != DD_OK) //couldn't lock surface so exit
	{
		pTempImage->Unlock(NULL);
		pTempImage->Release();
		return -3;
	}
	int bytesPerPixel = ddsd.ddpfPixelFormat.dwRGBBitCount/8;
	int pitch = (int) ddsd.lPitch; //get the pitch 
	byte* pSurface = (byte*) ddsd.lpSurface; //Grab surface pointer

	//Write the pixel info
	if (angle == 0) { //angle = 0 degrees
		for (int b=0;b<pImage->imageHeight;b++)
		{	
		memcpy(pTempSurface+b*tempPitch,pSurface+b*pitch,pitch);
		}}		
	else if (angle == 1) {//angle = 90 degrees clockwise
		for (int a=0;a<pImage->imageWidth;a++){
		for (int b=0;b<pImage->imageHeight;b++){
		for (int c=0;c<bytesPerPixel;c++){
		*(pTempSurface + (pImage->imageHeight-1-b)*bytesPerPixel 
			+ a*tempPitch + c) = 
			*(pSurface + a*bytesPerPixel + b*pitch + c);
		}}}}
	else if (angle == 2) {//angle = 180 degrees		
		for (int a=0;a<pImage->imageWidth;a++){
		for (int b=0;b<pImage->imageHeight;b++){
		for (int c=0;c<bytesPerPixel;c++){
		*(pTempSurface + (pImage->imageWidth-1-a)*bytesPerPixel
			+ (pImage->imageHeight-1-b)*tempPitch + c) = 
			*(pSurface + a*bytesPerPixel + b*pitch + c);
		}}}}	
	else if (angle == 3) {//angle = 270 degrees clockwise		
		for (int a=0;a<pImage->imageWidth;a++){
		for (int b=0;b<pImage->imageHeight;b++){
		for (int c=0;c<bytesPerPixel;c++){
		*(pTempSurface + b*bytesPerPixel + 
			(pImage->imageWidth-1-a)*tempPitch + c) = 
			*(pSurface + a*bytesPerPixel + b*pitch + c);
		}}}}

	//Unlock the surfaces
	pImage->pSurface->Unlock(NULL);
	pTempImage->Unlock(NULL);

	//Now delete the original image and put the new image
	//in its place
	pImage->pSurface->Release();
	pImage->pSurface = pTempImage;
	pImage->imageWidth = tempImageWidth;
	pImage->imageHeight = tempImageHeight;
	pImage->frameWidth = pImage->imageWidth;//if animated, width of frame
	pImage->frameHeight = pImage->imageHeight;//if animated, height of frame
	if (g_AutoMidHandle == true)
	{
	pImage->xHandle = pImage->imageWidth/2;
	pImage->yHandle = pImage->imageHeight/2;
	}

	//If appropriate, mask the new image the same as the original
	if (pImage->isMasked == true)
	{
	DDCOLORKEY ddck;
	ddck.dwColorSpaceLowValue = pImage->convertedMaskColor;
	ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
	pImage->pSurface->SetColorKey(DDCKEY_SRCBLT, &ddck);
	}

	return angle;//hr;
}


//-----------------------------------------------------------------------------
// Name: SaveBufferBB
// Desc: Saves the designated image (or buffer) as a bmp file.
//	Based on code by Michael Ftsch, which can be found at 
//	http://www.geocities.com/foetsch/screenshot/screenshot.htm
//-----------------------------------------------------------------------------
int SaveBufferBB CHARPARAMS
{
	char* FileName = in;//file name of bitmap
	LPDIRECTDRAWSURFACE7 lpDDS = g_pCurrentSurface;

	if (!FileName || !lpDDS) return false;
	int ErrorCode = 1;

	HDC SurfDC=NULL;        // GDI-compatible device context for the surface
	HBITMAP OffscrBmp=NULL; // bitmap that is converted to a DIB
	HBITMAP OldBmp=NULL;
	int Width = 0; //image width
	int Height = 0; //image height
	HDC OffscrDC=NULL;      // offscreen DC that we can select OffscrBmp into
	LPBITMAPINFO lpbi=NULL; // bitmap format info; used by GetDIBits
	LPVOID lpvBits=NULL;    // pointer to bitmap bits array
	HANDLE BmpFile=INVALID_HANDLE_VALUE;    // destination .bmp file
	BITMAPFILEHEADER bmfh;  // .bmp file header

	// Get dimensions of Surface:
	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	if (FAILED(lpDDS->GetSurfaceDesc(&ddsd)))
		{ErrorCode = -1; goto cleanUp;}
	Width = ddsd.dwWidth;
	Height = ddsd.dwHeight;

	// Create a GDI-compatible device context for the surface:
	if (FAILED(lpDDS->GetDC(&SurfDC))) 
		{ErrorCode = -2; goto cleanUp;}

	// We need an HBITMAP to convert it to a DIB:
	if ((OffscrBmp = CreateCompatibleBitmap(SurfDC, Width, Height)) == NULL)
        {ErrorCode = -3; goto cleanUp;}

	// The bitmap is empty, so let's copy the contents of the surface to it.
	// For that we need to select it into a device context. We create one.
	if ((OffscrDC = CreateCompatibleDC(SurfDC)) == NULL) 
		{ErrorCode = -4; goto cleanUp;}
	// Select OffscrBmp into OffscrDC:
	OldBmp = (HBITMAP)SelectObject(OffscrDC, OffscrBmp);
	// Now we can copy the contents of the surface to the offscreen bitmap:
	BitBlt(OffscrDC, 0, 0, Width, Height, SurfDC, 0, 0, SRCCOPY);

	// We don't need SurfDC anymore. Free it:
	lpDDS->ReleaseDC(SurfDC); SurfDC = NULL;

	// GetDIBits requires format info about the bitmap. We can have GetDIBits
	// fill a structure with that info if we pass a NULL pointer for lpvBits:
	// Reserve memory for bitmap info (BITMAPINFOHEADER + largest possible
	// palette):
	if ((lpbi = (LPBITMAPINFO)(new char[sizeof(BITMAPINFOHEADER) +
        256 * sizeof(RGBQUAD)])) == NULL) 
		{ErrorCode = -5; goto cleanUp;}
	ZeroMemory(&lpbi->bmiHeader, sizeof(BITMAPINFOHEADER));
	lpbi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	// Get info but first de-select OffscrBmp because GetDIBits requires it:
	SelectObject(OffscrDC, OldBmp);
	if (!GetDIBits(OffscrDC, OffscrBmp, 0, Height, NULL, lpbi, DIB_RGB_COLORS))
        {ErrorCode = -6; goto cleanUp;}

	// Reserve memory for bitmap bits:
	if ((lpvBits = new char[lpbi->bmiHeader.biSizeImage]) == NULL)
        {ErrorCode = -7; goto cleanUp;}

	// Have GetDIBits convert OffscrBmp to a DIB (device-independent bitmap):
	if (!GetDIBits(OffscrDC, OffscrBmp, 0, Height, lpvBits, lpbi,
        DIB_RGB_COLORS)) {ErrorCode = -8; goto cleanUp;}

	// Create a file to save the DIB to:
	if ((BmpFile = CreateFile(FileName,
                              GENERIC_WRITE,
                              0, NULL,
                              CREATE_ALWAYS,
                              FILE_ATTRIBUTE_NORMAL,
                              NULL)) == INVALID_HANDLE_VALUE)
			{ErrorCode = -9; goto cleanUp;}

	DWORD Written;    // number of bytes written by WriteFile
    
	// Write a file header to the file:
	bmfh.bfType = 19778;        // 'BM'
	// bmfh.bfSize = ???        // we'll write that later
	bmfh.bfReserved1 = bmfh.bfReserved2 = 0;
	// bmfh.bfOffBits = ???     // we'll write that later
	if (!WriteFile(BmpFile, &bmfh, sizeof(bmfh), &Written, NULL))
        {ErrorCode = -10; goto cleanUp;}
	if (Written < sizeof(bmfh)) {ErrorCode = -11; goto cleanUp;}

	// Write BITMAPINFOHEADER to the file:
	if (!WriteFile(BmpFile, &lpbi->bmiHeader, sizeof(BITMAPINFOHEADER),
        &Written, NULL)) {ErrorCode = -12; goto cleanUp;}
	if (Written < sizeof(BITMAPINFOHEADER)) 
		{ErrorCode = -13; goto cleanUp;}

	// Calculate size of palette:
	int PalEntries;
	// 16-bit or 32-bit bitmaps require bit masks:
	if (lpbi->bmiHeader.biCompression == BI_BITFIELDS) PalEntries = 3;
	else
        // bitmap is palettized?
        PalEntries = (lpbi->bmiHeader.biBitCount <= 8) ?
		// 2^biBitCount palette entries max.:
            (int)(1 << lpbi->bmiHeader.biBitCount)
		// bitmap is TrueColor -> no palette:
        : 0;
	// If biClrUsed use only biClrUsed palette entries:
	if (lpbi->bmiHeader.biClrUsed) PalEntries = lpbi->bmiHeader.biClrUsed;

	// Write palette to the file:
	if (PalEntries)
	{
        if (!WriteFile(BmpFile, &lpbi->bmiColors, PalEntries * sizeof(RGBQUAD),
            &Written, NULL)) {ErrorCode = -14; goto cleanUp;}
        if (Written < PalEntries * sizeof(RGBQUAD)) 
			{ErrorCode = -15; goto cleanUp;}
	}

	// The current position in the file (at the beginning of the bitmap bits)
	// will be saved to the BITMAPFILEHEADER:
	bmfh.bfOffBits = SetFilePointer(BmpFile, 0, 0, FILE_CURRENT);

	// Write bitmap bits to the file:
	if (!WriteFile(BmpFile, lpvBits, lpbi->bmiHeader.biSizeImage,
        &Written, NULL)) {ErrorCode = -16; goto cleanUp;}
	if (Written < lpbi->bmiHeader.biSizeImage) 
		{ErrorCode = -17; goto cleanUp;}

	// The current pos. in the file is the final file size and will be saved:
	bmfh.bfSize = SetFilePointer(BmpFile, 0, 0, FILE_CURRENT);

	// We have all the info for the file header. Save the updated version:
	SetFilePointer(BmpFile, 0, 0, FILE_BEGIN);
	if (!WriteFile(BmpFile, &bmfh, sizeof(bmfh), &Written, NULL))
        {ErrorCode = -18; goto cleanUp;}
	if (Written < sizeof(bmfh)) {ErrorCode = -19; goto cleanUp;}

  cleanUp:

	if (SurfDC) lpDDS->ReleaseDC(SurfDC);
	if (OffscrDC) DeleteDC(OffscrDC);
	if (OffscrBmp) DeleteObject(OffscrBmp);
	if (lpbi) delete[] lpbi;
	if (lpvBits) delete[] lpvBits;
	if (BmpFile != INVALID_HANDLE_VALUE) CloseHandle(BmpFile);
    
	return ErrorCode;//returns 1 if everything's ok.
}


//-----------------------------------------------------------------------------
// Name: SetBrushBB()
// Desc: Sets the fill color/pattern used by GDI drawing operations 
//-----------------------------------------------------------------------------
int SetBrushBB STDPARAMS
{
	int r = *in; in++;
	int g = *in; in++;
	int b = *in; in++;
	int pattern = *in; in++;
	int style = *in; in++;
	int usedStyle = 0;

	if (g_hBrush != NULL) DeleteObject(g_hBrush);
	g_hBrush = NULL;
	if (pattern == 0) 
		g_hBrush = CreateSolidBrush(RGB(r,g,b));
	if (pattern == 1) 
	{
		if (style == 0) usedStyle = HS_BDIAGONAL;
		if (style == 1) usedStyle = HS_CROSS;
		if (style == 2) usedStyle = HS_DIAGCROSS;
		if (style == 3) usedStyle = HS_FDIAGONAL;
		if (style == 4) usedStyle = HS_HORIZONTAL;
		if (style == 5) usedStyle = HS_VERTICAL;
		g_hBrush = CreateHatchBrush(usedStyle,RGB(r,g,b));
	}
	return (1);
}


//-----------------------------------------------------------------------------
// Name: SetBufferBB
// Desc: Changes the current drawing buffer to the front buffer, back
// buffer, or an image buffer.
//-----------------------------------------------------------------------------
void SetBufferBB INTPARAMS
{
	unsigned int pointer = *in; in++;

	if (pointer == 1)//if setting buffer to front buffer
	{
		g_pCurrentBuffer = 1;
		g_pCurrentImage = NULL;//pointer to the cImage in buffer
		g_pCurrentSurface = g_pFrontBuffer;//pointer to the surface in buffer
		return;
	}

	if (pointer == 2) //if setting buffer to back buffer
	{
		g_pCurrentBuffer = 2;
		g_pCurrentImage = NULL;//pointer to the cImage in buffer
		g_pCurrentSurface = g_pBackBuffer;//pointer to the surface in buffer
		return;
	}

	//If setting buffer to image buffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return;//error check
	if(pImage->pSurface == NULL) return;//error check

	g_pCurrentBuffer = 3;
	g_pCurrentImage = pImage;//pointer to the cImage in buffer
	g_pCurrentSurface = pImage->pSurface;//pointer to the surface in buffer
}


//-----------------------------------------------------------------------------
// Name: SetFont()
// Desc: Designates a font typeface for use by text functions 
// Some typical typefaces are Arial, Courier New, Garamond, Times New Roman 
//-----------------------------------------------------------------------------
int SetFontBB STDPARAMS
{
	int typesize = *in; in = in+1;
	int bold = *in; in = in+1;
	int italic = *in; in = in+1;
	int underline = *in; in = in+1;
	char* typeface = (char*) in;

	int weight = 0;
	if (bold==0) weight = 200;
	if (bold==1) weight = 700;

	if (g_hFont != NULL) DeleteObject(g_hFont);
	g_hFont = NULL;
	g_hFont = CreateFont(
		typesize,//height of font
		0,//int average character width
		0,//int angle of escapement
		0,//int base-line orientation angle
		weight,//font weight 0-1000 
		italic,//DWORD italic attribute option
		underline,//DWORD underline attribute option
		0,//DWORD strikeout attribute option
		0,//DEFAULT_CHARSET,//DWORD character set identifier
		0,//OUT_DEFAULT_PRECIS,//DWORD output precision
		0,//CLIP_DEFAULT_PRECIS,//DWORD clipping precision
		0,//DWORD output quality
		0,//DWORD pitch and family
		typeface);//LPCTSTR typeface name

	return 1;
}


//-----------------------------------------------------------------------------
// Name: SetFontColorBB()
// Desc: Sets the default text color  
//-----------------------------------------------------------------------------
int SetFontColorBB STDPARAMS
{
	int r = *in; in++;
	int g = *in; in++;
	int b = *in;
	g_FontColor = RGB(r,g,b); 
	return(1);
}


//-----------------------------------------------------------------------------
// Name: SetMouseSpeedBB()
// Desc: Set the current mouse speed. Starting value is 2. 
//-----------------------------------------------------------------------------
void SetMouseSpeedBB INTPARAMS
{
	g_MouseSpeed = *in;
}


//-----------------------------------------------------------------------------
// Name: SetPaletteBB
// Desc: Sets the palette after it has been changed using WritePaletteBB
//	The default settings set the entire palette. You can also just change
//	a single entry in the palette or a range of entries, and only those
//	entries in the g_PaletteEntry array will be changed.
//-----------------------------------------------------------------------------
int SetPaletteBB BYTEPARAMS
{
	HRESULT hr=0;
	byte startingEntry = *in; in++;//default is 0
	byte entryCount = *in; //default is 256
	if (g_pPalette != NULL) 
	{
		hr = g_pPalette->
		SetEntries(0,startingEntry,entryCount,&g_PaletteEntry[startingEntry]);
	}

	if (hr == DD_OK) 
		return 1;
	else
		return -1;	
}


//-----------------------------------------------------------------------------
// Name: SetPenBB()
// Desc: Sets the current pen used by GDI drawing operations 
//-----------------------------------------------------------------------------
int SetPenBB STDPARAMS
{
	int r = *in; in++;
	int g = *in; in++;
	int b = *in; in++;
	int thickness = *in; in++; 
	int style = *in; 

	int usedStyle = 0;
	if (style == 0) usedStyle = PS_SOLID;
	if (style == 1) usedStyle = PS_DASH;//thickness = 1 pixel 
	if (style == 2) usedStyle = PS_DOT;//thickness = 1 pixel 
	if (style == 3) usedStyle = PS_DASHDOT;//thickness = 1 pixel 
	if (style == 4) usedStyle = PS_DASHDOTDOT;//thickness = 1 pixel 
	if (style == 5) usedStyle = PS_NULL;

	if (g_hPen != NULL) DeleteObject(g_hPen);
	g_hPen = NULL;
	g_hPen = CreatePen(
		usedStyle, //int pen style
		thickness, //int pen width; 0 = 1 pixel
		RGB(r,g,b)); //COLORREF pen color 
	return (1);
}


//-----------------------------------------------------------------------------
// Name: ShowPointerBB
// Desc: Shows the Windows cursor (default = off)
//-----------------------------------------------------------------------------
void ShowPointerBB INTPARAMS
{
	ShowCursor(TRUE);
}


//-----------------------------------------------------------------------------
// Name: TextBB()
// Desc: Draws a text string on the current DirectDraw surface using 
//	g_hFont or the default GDI font if g_hFont is NULL.
//-----------------------------------------------------------------------------
int TextBB STDPARAMS
{	
	//Choose screen dimensions.
	int x = *in; in = in+1;
	int y = *in; in = in+1;
	char* pText = (char*) in;
				
	HDC     hDC = NULL;

	g_pCurrentSurface->Restore(); //Make sure the surface is restored	
	g_pCurrentSurface->GetDC(&hDC);//Get the DC of the surface
	SetTextColor( hDC, g_FontColor);// Set text color
	SetBkMode(hDC, TRANSPARENT); //Make it transparent
	if (g_hFont) SelectObject(hDC,g_hFont);//Use the selected font, if any
	TextOut( hDC, x, y, pText, strlen(pText)); 
	g_pCurrentSurface->ReleaseDC( hDC );
	return 1;
}


//-----------------------------------------------------------------------------
// Name: Tint3DImageBB
// Desc: Sets the vertex color for a 3D image.
//-----------------------------------------------------------------------------
int Tint3DImageBB INTPARAMS
{ 	
	//Get and translate the image pointer
	unsigned int pointer = *in; in++;
	if (pointer == 1 || pointer == 2) return 0; //not front or backbuffer
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	if(pImage == NULL) return -1;
	if(pImage->pSurface == NULL) return -2;

	int r = *in; in++;
	int g = *in; in++;
	int b = *in;
	pImage->pStats3D->vertexColor = RGB_MAKE(r,g,b);	
	return 1;
}


//-----------------------------------------------------------------------------
// Name: TextureSearchCallback()
// Desc: Enumeration callback routine to find a 16-bit texture format.
//	Needs to be upgraded.
//-----------------------------------------------------------------------------
static HRESULT CALLBACK TextureSearchCallback(DDPIXELFORMAT* pddpf, VOID* param)
{
    // Note: Return with DDENUMRET_OK to continue enumerating more formats.

    // Skip any funky modes
    if( pddpf->dwFlags & (DDPF_LUMINANCE|DDPF_BUMPLUMINANCE|DDPF_BUMPDUDV) )
        return DDENUMRET_OK;
    
    // Skip any FourCC formats
    if( pddpf->dwFourCC != 0 )
        return DDENUMRET_OK;

    // We only want screen-depth's format, so skip all others
    if( pddpf->dwRGBBitCount != (DWORD) g_screenDepth)
        return DDENUMRET_OK;

    //If not looking for an alpha mode
    if(g_TextureSearchOption == 0)
	{
    if(pddpf->dwFlags&DDPF_ALPHAPIXELS) return DDENUMRET_OK;

    // We found a good match. Copy the current pixel format to our output
    // parameter
    memcpy( (DDPIXELFORMAT*)param, pddpf, sizeof(DDPIXELFORMAT) );
	}

    //If looking for an alpha mode
    if(g_TextureSearchOption == 1)
	{
    if(pddpf->dwFlags&DDPF_ALPHAPIXELS && g_screenDepth == 16 &&	
		pddpf->dwRGBAlphaBitMask == 0x0000F000)
	{
		memcpy((DDPIXELFORMAT*)param, pddpf, sizeof(DDPIXELFORMAT));
	}
    else if(pddpf->dwFlags&DDPF_ALPHAPIXELS && g_screenDepth == 32 
		&&	pddpf->dwRGBAlphaBitMask == 0xFF000000)
	{
		memcpy((DDPIXELFORMAT*)param, pddpf, sizeof(DDPIXELFORMAT));
	}
	else
	{
		return DDENUMRET_OK;
	}
	}

    // Return with DDENUMRET_CANCEL to end enumeration.
    return DDENUMRET_CANCEL;
}



//-----------------------------------------------------------------------------
// Name: TotalSysMemBB
// Desc: Returns the total physical system memory in bytes.
//-----------------------------------------------------------------------------
int TotalSysMemBB STDPARAMS
{ 	
	MEMORYSTATUS stat;
	GlobalMemoryStatus (&stat);
	return(stat.dwTotalPhys);
}


//-----------------------------------------------------------------------------
// Name: TotalVidMemBB()
// Desc: Returns the available video memory in bytes
//-----------------------------------------------------------------------------
int TotalVidMemBB STDPARAMS 
{
	DWORD totalVRAM=0;
	DWORD freeVRAM=0;
	DDSCAPS2 ddscaps;
	ZeroMemory(&ddscaps, sizeof(ddscaps));//clear memory block for structure
	ddscaps.dwCaps = DDSCAPS_VIDEOMEMORY;  
	g_pDirectDraw->GetAvailableVidMem(&ddscaps,&totalVRAM,&freeVRAM);
	return totalVRAM;
}  


//-----------------------------------------------------------------------------
// Name: UnlockBlitzMouseBB
// Desc: Frees the Windows mouse so that the native Blitz mouse can
// work properly. Only used in Blitz Plus because it creates a full
// screen popup window that doesn't pose problems.
//-----------------------------------------------------------------------------
void UnlockBlitzMouseBB INTPARAMS
{
	g_UseBlitzMouse = true;
}


//-----------------------------------------------------------------------------
// Name: UpdateMouseBB
// Desc: Updates the mouse by using Direct Input.
//-----------------------------------------------------------------------------
void UpdateMouseBB INTPARAMS
{
	g_pMouse->GetDeviceState(sizeof(g_pMouseData), &g_pMouseData);

	//Get and calculate current mouse position info.
	if (abs(g_pMouseData.lX) <= 10) 
		g_CurrentMouseX = g_CurrentMouseX+g_pMouseData.lX;
	else
		g_CurrentMouseX = g_CurrentMouseX+g_MouseSpeed*g_pMouseData.lX;
	if (g_CurrentMouseX < 0) g_CurrentMouseX = 0;
	if (g_CurrentMouseX >= g_screenWidth) g_CurrentMouseX = g_screenWidth-1;

	if (abs(g_pMouseData.lY) <= 10) 
		g_CurrentMouseY = g_CurrentMouseY+g_pMouseData.lY;
	else 
		g_CurrentMouseY = g_CurrentMouseY+g_MouseSpeed*g_pMouseData.lY;
	if (g_CurrentMouseY < 0) g_CurrentMouseY = 0;
	if (g_CurrentMouseY >= g_screenHeight) g_CurrentMouseY = g_screenHeight-1;

	//Return mouse x and y location
	*out = g_CurrentMouseX; out++;
	*out = g_CurrentMouseY; out++;

	//Return left button status
	if (g_pMouseData.rgbButtons[0] & 0x80)
		{*out = 1; out++;}
	else
		{*out = 0; out++;}

	//Return right button status
	if (g_pMouseData.rgbButtons[1] & 0x80)
		{*out = 1; out++;}
	else
		{*out = 0; out++;}

	*out = g_pMouseData.lX; out++;
	*out = g_pMouseData.lY; out++;
}


//-----------------------------------------------------------------------------
// Name: UpdateWindowsMouseBB
// Desc: Updates the mouse by using the Windows GetCursorPos command.
//-----------------------------------------------------------------------------
void UpdateWindowsMouseBB INTPARAMS
{
	POINT pt;
	GetCursorPos(&pt);
	*out = pt.x; out++;
	*out = pt.y;
}


//-----------------------------------------------------------------------------
// Name: WindowStatusBB
// Desc: Returns whether the game window is active.
//-----------------------------------------------------------------------------
int WindowStatusBB INTPARAMS
{
	if (g_hWndGame != GetFocus()) return 0;
	return 1;
}


//-----------------------------------------------------------------------------
// Name: WritePaletteBB
// Desc: Writes an RGB value to a given palette entry in a 256 color palette.
//	This command will not actually change the palette itself. To change the
//	palette, you need to use SetPaletteBB after you have changed the palette
//	entries to whatever you want. 
//-----------------------------------------------------------------------------
void WritePaletteBB BYTEPARAMS
{
	byte iColor = *in; in++;
	g_PaletteEntry[iColor].peRed = *in; in++;
	g_PaletteEntry[iColor].peGreen = *in; in++;
	g_PaletteEntry[iColor].peBlue = *in;
}


//-----------------------------------------------------------------------------
// Name: WritePixelBB
// Desc: Writes a pixel to the specified location in the current drawing
// buffer. If in 16 bit display mode or greater, the specified rgb color
// is written. If in 8 bit mode, the first parameter is used and treated
// as a palette entry (0-255).
//-----------------------------------------------------------------------------
int WritePixelBB INTPARAMS
{
	//Get incoming info
	int x = *in; in++;
	int y = *in; in++;
	int r = *in; in++;
	int g = *in; in++;
	int b = *in;

	//Do some error checking on the coordinates vs. current
	//drawing buffer.
	if (g_pCurrentBuffer == 1 || g_pCurrentBuffer == 2)
	{
		if (x >= g_screenWidth) return -1;		
		if (y >= g_screenHeight) return -2;
	}
	else if (g_pCurrentBuffer == 3)
	{
		if (g_pCurrentImage->imageIs3D == true) return -3;//too slow for 3D images
		if (x >= g_pCurrentImage->imageWidth) return -4;
		if (y >= g_pCurrentImage->imageHeight) return -5;
	}
	else
		return -6;

	//Set up the Direct Draw surface description
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);

	//Lock the surface
	HRESULT hr = g_pCurrentSurface->Lock(
		NULL,//lock entire surface
		&ddsd,  
		DDLOCK_WAIT | DDLOCK_NOSYSLOCK,                    
		NULL);
	if (hr != DD_OK) return -7;//couldn't lock surface so exit

	int pitch = ddsd.lPitch; //get the pitch 
	int pixelFormat = ddsd.ddpfPixelFormat.dwRGBBitCount;

	//Write the pixel
	if (pixelFormat == 8)
	{
		byte* pSurface = (byte*) ddsd.lpSurface;
		*(pSurface+x+y*pitch) = (byte) r;
	}
	else if (pixelFormat == 16)
	{
		short pixel=0;
		if (g_screenFormat16Bit == 555)
			pixel = ((r/8)<<10) + ((g/8)<<5) + (b/8);  
		else if (g_screenFormat16Bit == 565)
			pixel = ((r/8)<<11) + ((g/4)<<5) + (b/8);
		else 
			pixel = 0; //error
		short* pSurface = (short*) ddsd.lpSurface;
		*(pSurface+x+y*pitch/2) = pixel;
	}
	else if (pixelFormat == 24)
	{
		byte* pSurface = (byte*) ddsd.lpSurface;
		*(pSurface+x*3+y*pitch+2) = (byte) r;
		*(pSurface+x*3+y*pitch+1) = (byte) g;
		*(pSurface+x*3+y*pitch+0) = (byte) b;
	}
	else if (pixelFormat == 32)
	{
		byte* pSurface = (byte*) ddsd.lpSurface;
		*(pSurface+x*4+y*pitch+3) = 255;//unused alpha
		*(pSurface+x*4+y*pitch+2) = (byte) r;
		*(pSurface+x*4+y*pitch+1) = (byte) g;
		*(pSurface+x*4+y*pitch+0) = (byte) b;
	}
	else 
		b = 0; //dummy statement
	
	//Unlock the surface
	g_pCurrentSurface->Unlock(NULL);
	return 0;
}


//-----------------------------------------------------------------------------
// Name: WritePixelFastBB
// Desc: Writes a batch of pixels to a selected image surface.
//
// Some stats from my lowly laptop:
// --------------------------------
// Extended WritePixel = 22 pixels/ms
// Native Blitz WritePixel = 33 pixels/ms

// Extended WritePixelFast 8 bit/RAM image = 1250 pixels/ms
// Extended WritePixelFast 16 bit/RAM image = 770 pixels/ms
// Extended WritePixelFast 16 bit/VRAM image = 555 pixels/ms
// Native Blitz WritePixelFast 16 bit/VRAM = 1216 pixels/ms

//-----------------------------------------------------------------------------
int WritePixelFastBB INTPARAMS
{

	//Get and translate the image pointer
	unsigned int pointer = *in; in++;
	cImage* pImage = (cImage*) pointer;//type cast to convert back to pointer	
	int numberPixelsWritten = *in; in = in+4;

	LPDIRECTDRAWSURFACE7 thisImage=NULL;
	if (pointer == 1)
		thisImage = g_pFrontBuffer;
	else if (pointer == 2)
		thisImage = g_pBackBuffer;
	else
	{
	if (pImage->imageIs3D == true) return 0;//too slow for 3D images
	if(pImage == NULL) return -1;
	if(pImage->pSurface == NULL) return -2;
	thisImage = pImage->pSurface;
	}

	//Set up the Direct Draw surface description
	DDSURFACEDESC2 ddsd; //surface description data structure
	ZeroMemory(&ddsd, sizeof(ddsd));// zero-out the memory area
	ddsd.dwSize = sizeof(ddsd);

	//Lock the surface
	HRESULT hr = thisImage->Lock(
		NULL,//lock entire surface
		&ddsd,  
		DDLOCK_WAIT | DDLOCK_NOSYSLOCK,                    
		NULL);
	if (hr != DD_OK) return -3;//couldn't lock surface so exit
	int pitch = ddsd.lPitch; //get the pitch 
	void* pSurfacePointer = ddsd.lpSurface; //get pointer to surface memory

	//Write the pixels
	if (g_screenDepth == 8){
	byte* pSurface = (byte*) pSurfacePointer;
	for (int a=0;a<numberPixelsWritten;a++)
	{
		int x = *in; in++;
		int y = *in; in++;
		*(pSurface+x+y*pitch) = *in; in=in+3;
	}
	}
	else if (g_screenDepth == 16)
	{
		for (int a=0;a<numberPixelsWritten;a++){
		int x = *in; in++;
		int y = *in; in++;
		int r = *in; in++;
		int g = *in; in++;
		int b = *in; in++;
		short pixel=0;
		if (g_screenFormat16Bit == 555)
			pixel = ((r/8)<<10) + ((g/8)<<5) + (b/8);  
		else if (g_screenFormat16Bit == 565)
			pixel = ((r/8)<<11) + ((g/4)<<5) + (b/8);
		else 
			pixel = 0; //error
		short* pSurface = (short*) pSurfacePointer;
		*(pSurface+x+y*pitch/2) = pixel;
		}
	}
	else if (g_screenDepth == 24)
	{
		for (int a=0;a<numberPixelsWritten;a++){
		int x = *in; in++;
		int y = *in; in++;
		int r = *in; in++;
		int g = *in; in++;
		int b = *in; in++;
		byte* pSurface = (byte*) pSurfacePointer;
		*(pSurface+x*3+y*pitch+2) = (byte) r;
		*(pSurface+x*3+y*pitch+1) = (byte) g;
		*(pSurface+x*3+y*pitch+0) = (byte) b;
		}
	}
	else if (g_screenDepth == 32)
	{
		for (int a=0;a<numberPixelsWritten;a++){
		int x = *in; in++;
		int y = *in; in++;
		int r = *in; in++;
		int g = *in; in++;
		int b = *in; in++;
		byte* pSurface = (byte*) pSurfacePointer;
		*(pSurface+x*4+y*pitch+3) = (byte) r;//unused alpha
		*(pSurface+x*4+y*pitch+2) = (byte) r;
		*(pSurface+x*4+y*pitch+1) = (byte) g;
		*(pSurface+x*4+y*pitch+0) = (byte) b;
		}
	}
	else 
		return -1; //dummy statement

	//Unlock the surface
	thisImage->Unlock(NULL);

	return 1;
}


//-----------------------------------------------------------------------------
// Name: WriteStringBB
// Desc: Returns a null-terminated string. Not used.
//-----------------------------------------------------------------------------
int WriteStringBB CHARPARAMS
{ 	
	char string[] = "Hey there!"; int i = 0;
	while (string[i] != 0)
	{
	*out = string[i]; out++; i++; 
	}
	*out = NULL;//add the null character
	return(1);
}


